/* Simulate the text used in the menus and the intermission screens. */
/* These tables are based on those in Retro Doom by Brad Harding. */
/* J.A.Doggett. */

#include "includes.h"

#define TRNP 0x20		// Transparent

#define FONT_START	0x21
#define FONT_END	0x7F

/* ---------------------------------------------------------------------------- */
/* In these tables the first character is the width in pixels, */
/* the second character is the number of rows, and the third */
/* character is the offset to add to y before starting. */

static const unsigned char red_char_21 [] =
{
  8,16,0,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB1,0xB1,0xB2,0xB1,0x2F,0xFB,
  TRNP,0x2F,0xB3,0xB3,0xB3,0xB1,0x2F,0xFB,
  TRNP,0x2F,0xB4,0xB3,0xB2,0xB2,0x2F,0xFB,
  TRNP,0x2F,0xB4,0xB3,0xB2,0xB2,0x2F,0xFB,
  TRNP,0x2F,0xB4,0xB3,0xB2,0xB2,0x2F,0xFB,
  TRNP,0x2F,0xB4,0xB4,0xB2,0xB1,0x2F,0xFB,
  TRNP,0x2F,0xB3,0xB4,0xB3,0xB5,0x2F,0xFB,
  TRNP,0x2F,0xB7,0xB4,0xB4,0xB6,0x2F,0xFB,
  TRNP,0x2F,0x2F,0xB8,0xB9,0x2F,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xB7,0xB7,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xBA,0xBA,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,TRNP
};

static const unsigned char red_char_25 [] =
{
  13,12,3,
  TRNP,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,
  0xBF,0xB6,0xB4,0xB2,0xBF,TRNP,TRNP,TRNP,0xBF,0xB5,0xB2,0xB3,0xBF,
  0xBF,0xBB,0xBA,0xB9,0xBF,TRNP,TRNP,0xBF,0xB5,0xB6,0xB2,0xB8,0xBF,
  TRNP,0xBF,0xBF,0xBF,TRNP,TRNP,0xBF,0xB5,0xB9,0xB6,0xB8,0xBF,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xB5,0xB9,0xB9,0xBC,0xBF,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0xBF,0xB5,0xBD,0xBA,0xBC,0xBF,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0xBF,0xB5,0xBA,0x2A,0xBD,0xBF,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0xBF,0xB5,0xB8,0xB8,0x2B,0xBF,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xBF,0xB1,0xB8,0xBA,0xBC,0xBF,TRNP,TRNP,0xBF,0xBF,0xBF,TRNP,
  0xBF,0xB1,0xB6,0xB8,0xBC,0xBF,TRNP,TRNP,0xBF,0xB6,0xB4,0xB2,0xBF,
  0xBF,0xB7,0xB5,0xB8,0xBF,TRNP,TRNP,TRNP,0xBF,0xBB,0xBA,0xB9,0xBF,
  0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,TRNP
};

static const unsigned char red_char_27 [] =
{
  7,6,0,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0xB2,0xB2,0x2F,0xFB,
  TRNP,TRNP,0x2F,0xB5,0xB7,0x2F,0xFB,
  TRNP,0x2F,0xB9,0xB9,0x2F,0xFB,0xFB,
  TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_2C [] =
{
  7,6,12,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0xB2,0xB2,0x2F,0xFB,
  TRNP,TRNP,0x2F,0xB5,0xB7,0x2F,0xFB,
  TRNP,0x2F,0xB9,0xB9,0x2F,0xFB,0xFB,
  TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_2D [] =
{
  11,6,6,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xBA,0xB4,0xB4,0xB2,0xB2,0xB7,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xBC,0xB9,0xB9,0xB6,0xB6,0xBB,0x2F,0xFB,TRNP,
  TRNP,0x2F,0xBB,0xBA,0xBA,0xBA,0xBA,0xBB,0x2F,0xFB,TRNP,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,
  TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP
};

static const unsigned char red_char_2E [] =
{
  6,5,11,
  TRNP,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB8,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB5,0x2F,0xFB,
  TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_2F [] =
{
  10,13,3,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,TRNP,
  TRNP,TRNP,TRNP,TRNP,0xBF,0xBA,0xB1,0xB5,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,0xBF,0xB7,0xB1,0xB7,0xBF,0xFB,
  TRNP,TRNP,TRNP,0xBF,0xBA,0xB1,0xB5,0xBF,0xFB,0xFB,
  TRNP,TRNP,TRNP,0xBF,0xB7,0xB1,0xBA,0xBF,0xFB,TRNP,
  TRNP,TRNP,0xBF,0xBA,0xB1,0xB5,0xBF,0xFB,0xFB,TRNP,
  TRNP,TRNP,0xBF,0xB5,0xB1,0xBA,0xBF,0xFB,TRNP,TRNP,
  TRNP,0xBF,0xBA,0xB1,0xB5,0xBF,0xFB,0xFB,TRNP,TRNP,
  TRNP,0xBF,0xB5,0xB1,0xBA,0xBF,0xFB,TRNP,TRNP,TRNP,
  0xBF,0xBA,0xB1,0xB5,0xBF,0xFB,0xFB,TRNP,TRNP,TRNP,
  0xBF,0xB5,0xB1,0xBA,0xBF,0xFB,TRNP,TRNP,TRNP,TRNP,
  0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_30 [] =
{
  12,13,3,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,
  TRNP,0xBF,0xB2,0xB1,0xAF,0xAF,0xAF,0xB4,0xB5,0xBF,TRNP,TRNP,
  0xBF,0xB7,0xB3,0xB4,0xB9,0xB9,0xBA,0xB7,0xB5,0xB9,0xBF,TRNP,
  0xBF,0xB7,0xB4,0xB7,0xBF,0xBF,0xBF,0xB7,0xB5,0xB7,0xBF,0xFB,
  0xBF,0xB7,0xB4,0xB7,0xBF,0xFB,0xBF,0xB7,0xB4,0xB8,0xBF,0xFB,
  0xBF,0xB7,0xB3,0xB7,0xBF,0xFB,0xBF,0xB9,0xB5,0xB8,0xBF,0xFB,
  0xBF,0xB7,0xB3,0xB8,0xBF,0xFB,0xBF,0xB8,0xB4,0xB8,0xBF,0xFB,
  0xBF,0xB7,0xB3,0xB8,0xBF,0xFB,0xBF,0xBB,0xB7,0xB8,0xBF,0xFB,
  0xBF,0xB7,0xB4,0xB6,0xBF,0xBF,0xBF,0xB9,0xB9,0xB9,0xBF,0xFB,
  0xBF,0xB9,0xB4,0xB2,0xB2,0xB3,0xB5,0xB9,0xB9,0xBC,0xBF,0xFB,
  TRNP,0xBF,0xBC,0xBB,0xB9,0xB9,0xB9,0xBB,0xBC,0xBF,0xFB,0xFB,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_31 [] =
{
  8,13,3,
  TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,TRNP,
  TRNP,TRNP,0xBF,0xAF,0xB1,0xB1,0xBF,0xFB,
  TRNP,0xBF,0xAF,0xB7,0xB3,0xB3,0xBF,0xFB,
  0xBF,0xB2,0xB7,0xB6,0xB3,0xB3,0xBF,0xFB,
  0xBF,0xBF,0xBF,0xB6,0xB3,0xB3,0xBF,0xFB,
  TRNP,0xFB,0xBF,0xB6,0xB3,0xB5,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xB2,0xB2,0xB3,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xB2,0xB2,0xB3,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xB3,0xB2,0xB5,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xB3,0xB2,0xB2,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xB9,0xB8,0xBA,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_32 [] =
{
  12,13,3,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,
  0xBF,0xB5,0xB2,0xAF,0xAF,0xAF,0xB1,0xB5,0xB5,0xBF,TRNP,TRNP,
  0xBF,0xB9,0xBA,0xB9,0xB9,0xB9,0xB8,0xB5,0xB6,0xB6,0xBF,TRNP,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB6,0xB6,0xB5,0xBF,0xFB,
  TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB7,0xB7,0xB3,0xBF,0xFB,
  TRNP,0xBF,0xB2,0xB3,0xB1,0xB1,0xB2,0xB6,0xB6,0xB5,0xBF,0xFB,
  0xBF,0xB2,0xB6,0xB6,0xB8,0xB9,0xB8,0xB9,0xBA,0xBF,0xFB,0xFB,
  0xBF,0xB3,0xB8,0xB8,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  0xBF,0xB5,0xB8,0xB6,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,
  0xBF,0xB1,0xB6,0xB6,0xB1,0xAF,0xAF,0xAF,0xAF,0xB1,0xBF,0xFB,
  0xBF,0xB8,0xB9,0xBB,0xBA,0xB7,0xB8,0xB9,0xBA,0xBA,0xBF,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_33 [] =
{
  12,13,3,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,
  0xBF,0xB5,0xB1,0xB1,0xAF,0xAF,0xB1,0xB2,0xB3,0xBF,TRNP,TRNP,
  0xBF,0xB6,0xB8,0xB9,0xB8,0xB8,0xB8,0xB8,0xB8,0xB7,0xBF,TRNP,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBB,0xB9,0xB8,0xBF,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xBF,0xBF,0xBF,0xBD,0xBA,0xB9,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,0xBF,0xAF,0xB2,0xB8,0xBA,0xB9,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,0xBF,0xB8,0xBB,0xBA,0xBA,0xB9,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,0xBD,0xBB,0xBA,0xBF,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBB,0xBB,0xBA,0xBF,0xFB,
  0xBF,0xB3,0xB5,0xB3,0xB5,0xB5,0xB5,0xBB,0xBB,0xBA,0xBF,0xFB,
  0xBF,0xBB,0xBB,0xBA,0xBB,0xBB,0xBD,0xBD,0xBD,0xBF,0xFB,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_34 [] =
{
  12,13,3,
  0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,
  0xBF,0xB2,0xB2,0xB6,0xBF,0xFB,0xBF,0xB1,0xB2,0xB6,0xBF,0xFB,
  0xBF,0xB2,0xB6,0xB9,0xBF,0xFB,0xBF,0xB1,0xB5,0xB8,0xBF,0xFB,
  0xBF,0xB5,0xB8,0xB6,0xBF,0xFB,0xBF,0xB1,0xB5,0xB9,0xBF,0xFB,
  0xBF,0xB6,0xB5,0xB3,0xBF,0xBF,0xBF,0xB1,0xB7,0xBA,0xBF,0xFB,
  0xBF,0xB3,0xB3,0xB1,0xAF,0xAF,0xAF,0xAF,0xB8,0xBA,0xBF,0xFB,
  0xBF,0xB8,0xB9,0xB7,0xB8,0xB9,0xB8,0xAF,0xB8,0xBA,0xBF,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xAF,0xB6,0xBA,0xBF,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xBF,0xAF,0xB6,0xB9,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xB1,0xB5,0xB9,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xB7,0xB9,0xBD,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_35 [] =
{
  12,13,3,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,
  0xBF,0xB4,0xB2,0xAF,0xAF,0xAF,0xAF,0xB2,0xB3,0xB5,0xBF,0xFB,
  0xBF,0xB5,0xB4,0xB4,0xB4,0xB6,0xB8,0xB6,0xB8,0xB8,0xBF,0xFB,
  0xBF,0xB6,0xB3,0xB9,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,
  0xBF,0xB6,0xB4,0xB9,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,0xFB,
  0xBF,0xB6,0xB4,0xB3,0xB2,0xAF,0xB2,0xB4,0xB5,0xBF,TRNP,TRNP,
  0xBF,0xB8,0xB8,0xB9,0xB9,0xB9,0xB9,0xB4,0xB5,0xB6,0xBF,TRNP,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB6,0xB8,0xBA,0xBF,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB7,0xBA,0xBA,0xBF,0xFB,
  0xBF,0xB4,0xAF,0xAF,0xAF,0xAF,0xB4,0xB7,0xBA,0xBA,0xBF,0xFB,
  0xBF,0xB8,0xB8,0xB8,0xB8,0xB9,0xB9,0xBA,0xBC,0xBF,0xFB,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_36 [] =
{
  12,13,3,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,
  TRNP,0xBF,0xB8,0xB3,0xAF,0xAF,0xB2,0xB2,0xB3,0xB5,0xBF,0xFB,
  0xBF,0xB7,0xB5,0xBA,0xB9,0xB8,0xB7,0xB8,0xB9,0xBA,0xBF,0xFB,
  0xBF,0xB6,0xB5,0xBA,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,
  0xBF,0xB4,0xB4,0xBA,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,0xFB,
  0xBF,0xB3,0xB5,0xB4,0xB3,0xB3,0xB4,0xB5,0xB8,0xBF,TRNP,TRNP,
  0xBF,0xB3,0xB5,0xB5,0xB8,0xB9,0xB9,0xB5,0xB5,0xB8,0xBF,TRNP,
  0xBF,0xB3,0xB6,0xB5,0xBF,0xBF,0xBF,0xB6,0xB3,0xB4,0xBF,0xFB,
  0xBF,0xB5,0xB8,0xB7,0xBF,0xBF,0xBF,0xB7,0xB4,0xB5,0xBF,0xFB,
  0xBF,0xB7,0xB5,0xB3,0xAF,0xAF,0xAF,0xB3,0xB4,0xB8,0xBF,0xFB,
  TRNP,0xBF,0xB7,0xB8,0xB8,0xB9,0xB8,0xB7,0xB8,0xBF,0xFB,0xFB,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_37 [] =
{
  12,13,3,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,
  0xBF,0xB6,0xB4,0xB2,0xAF,0xAF,0xAF,0xB2,0xB5,0xBF,TRNP,TRNP,
  0xBF,0xBB,0xBA,0xB9,0xBA,0xB9,0xBA,0xB7,0xB5,0xB7,0xBF,TRNP,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB7,0xB5,0xB7,0xBF,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xBF,0xB7,0xB4,0xB8,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xB9,0xB5,0xB9,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xB8,0xB4,0xBA,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBB,0xB7,0xBA,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBB,0xBB,0xBC,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBB,0xBC,0xBC,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBA,0xBB,0xBB,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_38 [] =
{
  12,13,3,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,
  TRNP,0xBF,0xB6,0xB5,0xB4,0xB2,0xB2,0xB4,0xB4,0xBF,TRNP,TRNP,
  0xBF,0xB8,0xB8,0xB7,0xBB,0xBC,0xBC,0xB7,0xB5,0xB7,0xBF,TRNP,
  0xBF,0xB9,0xB7,0xBC,0xBF,0xBF,0xBF,0xBC,0xB4,0xB8,0xBF,0xFB,
  0xBF,0xBA,0xB7,0xB9,0xBF,0xBF,0xBF,0xB9,0xB4,0xBB,0xBF,0xFB,
  TRNP,0xBF,0xB6,0xB6,0xB2,0xB3,0xB3,0xB4,0xB4,0xBF,0xFB,0xFB,
  TRNP,0xBF,0xB6,0xB9,0xB9,0xBB,0xBB,0xB8,0xB3,0xBF,0xFB,TRNP,
  0xBF,0xB8,0xB8,0xBB,0xBF,0xBF,0xBF,0xB9,0xB3,0xB9,0xBF,TRNP,
  0xBF,0xB5,0xB3,0xB9,0xBF,0xBF,0xBF,0xB6,0xB3,0xB5,0xBF,0xFB,
  0xBF,0xB9,0xB5,0xB3,0xB1,0xAF,0xB1,0xB4,0xB5,0xB9,0xBF,0xFB,
  TRNP,0xBF,0xB7,0xB9,0xBA,0xB9,0xB9,0xB9,0xB8,0xBF,0xFB,0xFB,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_39 [] =
{
  12,13,3,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,TRNP,
  TRNP,0xBF,0xBA,0xB5,0xB3,0xB2,0xB2,0xB3,0xB5,0xBF,TRNP,TRNP,
  0xBF,0xBE,0xBE,0xBC,0xBE,0xBE,0xBE,0xBA,0xBB,0xB6,0xBF,TRNP,
  0xBF,0xBC,0xBC,0xBB,0xBF,0xBF,0xBF,0xBA,0xBB,0xB5,0xBF,0xFB,
  0xBF,0xBA,0xB9,0xB9,0xBF,0xBF,0xBF,0xB8,0xBB,0xB5,0xBF,0xFB,
  0xBF,0xB8,0xB7,0xB9,0xB3,0xAF,0xB3,0xB8,0xBB,0xB6,0xBF,0xFB,
  TRNP,0xBF,0xBA,0xBB,0xBB,0xB9,0xB8,0xB6,0xBB,0xB7,0xBF,0xFB,
  TRNP,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB7,0xB9,0xB8,0xBF,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xB6,0xBB,0xB9,0xBF,0xFB,
  0xBF,0xB5,0xB4,0xB3,0xB3,0xB3,0xAF,0xB5,0xBE,0xBE,0xBF,0xFB,
  0xBF,0xBA,0xBA,0xBA,0xBB,0xBB,0xB9,0xB9,0xBE,0xBF,0xFB,0xFB,
  0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_3A [] =
{
  6,11,4,
  TRNP,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB8,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB5,0x2F,0xFB,
  TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB8,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB5,0x2F,0xFB,
  TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_3F [] =
{
  15,16,0,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xB7,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB4,0xB6,0xBA,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xBA,0xBC,0xB9,0xB9,0xB6,0xB8,0xB8,0xB6,0xB6,0xB5,0xBA,0x2F,TRNP,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB4,0xB3,0xB4,0xB6,0x2F,0xFB,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB3,0xB3,0xB5,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xB7,0xB1,0xB1,0xB1,0xB2,0xB1,0xB3,0xB5,0xB3,0xB3,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB9,0xB6,0xB1,0xB2,0xB9,0xB6,0xB9,0xB9,0xB7,0xBA,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBA,0xB6,0xB3,0xB1,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,0x2F,0xBA,0xB6,0xB4,0xB6,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,0x2F,0x2F,0xB8,0xB9,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xB7,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xBA,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_41 [] =
{
  19,16,0,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBD,0xB5,0xB3,0xB3,0xB3,0xB5,0xBD,0x2F,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB5,0xB6,0xB7,0xB7,0xB6,0xB6,0xB5,0xB6,0xBB,0x2F,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB6,0xB9,0xB8,0xB5,0xB9,0xB9,0xB9,0xB7,0xB5,0xB6,0xBD,0xFB,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xB8,0xB8,0xB8,0xB9,0x2F,0x2F,0x2F,0xB9,0xB5,0xB7,0xBB,0x2F,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB8,0xB7,0xB7,0xBC,0x2F,TRNP,0x2F,0xB9,0xB4,0xB7,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,0x2F,0xBB,0xB9,0xB6,0xB6,0xB8,0x2F,TRNP,TRNP,0x2F,0xBA,0xB4,0xB7,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,0x2F,0xBC,0xB9,0xB6,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0xBA,0xB5,0xB7,0xB9,0x2F,0xFB,
  TRNP,TRNP,0x2F,0xBA,0xBB,0xBB,0xB7,0xB9,0x2F,0x2F,0xB2,0xB2,0xB3,0xB5,0xB5,0xB7,0xB9,0x2F,0xFB,
  TRNP,TRNP,0x2F,0xBA,0xBB,0xBB,0xB9,0x2F,0xFB,0x2F,0xB9,0xB9,0xB9,0xB8,0xB5,0xB7,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBB,0xBA,0xBA,0xBA,0xB9,0x2F,0xFB,0x2F,0x2F,0x2F,0x2F,0xB8,0xB5,0xB8,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBB,0xBA,0xBB,0xBA,0x2F,0xFB,0xFB,TRNP,0xFB,0xFB,0x2F,0xB9,0xB6,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xBC,0xBB,0xB9,0xBA,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB5,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xBC,0xBB,0xBB,0xBB,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_42 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB7,0xB4,0xB3,0xB3,0xB4,0xB4,0xB4,0xB4,0xB5,0xB5,0xB7,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB7,0xB8,0xBA,0xBA,0xBA,0xB9,0xB9,0xB8,0xB7,0xB8,0xB7,0xB9,0x2F,TRNP,TRNP,
  0x2F,0xBB,0xBA,0xBB,0xBC,0xBC,0xBC,0xBC,0xBB,0xBB,0xBA,0xB8,0xB7,0xB9,0xBC,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB4,0xB5,0xB4,0xB4,0xB4,0xB4,0xB5,0xB5,0xB7,0xB9,0xB9,0xBC,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0xBA,0xBA,0xB9,0xB9,0xB8,0xB7,0xB8,0xB7,0xB9,0x2F,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0xBC,0xBC,0xBC,0xBB,0xBB,0xBA,0xB8,0xB7,0xB9,0xBC,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB6,0xB5,0xB6,0xB4,0xB4,0xB7,0xB7,0xB8,0xBB,0xB9,0xB9,0xBC,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB5,0xB6,0xB8,0xB9,0xB9,0xBA,0xBA,0xBB,0xBB,0xBC,0xBB,0x2F,0xFB,0xFB,
  0x2F,0xB9,0xB8,0xB9,0xBB,0xBA,0xBB,0xBC,0xBC,0xBC,0xBC,0xBC,0x2F,0x2F,0xFB,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_43 [] =
{
  18,16,0,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBA,0xB9,0xB7,0xB6,0xB6,0xB5,0xB5,0xB7,0xB9,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBD,0xBA,0xBB,0xBC,0xBB,0xBA,0xB9,0xBA,0xBA,0xB9,0xBD,0xBA,0xBA,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xBD,0x2D,0xBC,0xBB,0xBA,0xBC,0xBC,0xBC,0xBC,0xB9,0xBC,0xBC,0xBB,0xB9,0x2F,TRNP,
  0x2F,0xBD,0xBD,0xBB,0xBD,0xBC,0xBC,0x2F,0x2F,0x2F,0x2F,0xBA,0xBC,0xBD,0xBC,0xBA,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBD,0xBD,0xBC,0x2F,0xFB,0xFB,0xFB,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xBD,0xBC,0xBC,0xBC,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x2F,0xBD,0x2E,0xBD,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBD,0x2C,0xBC,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xBA,0xBC,0xBB,0xBD,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xBD,0xBA,0xBB,0xBA,0xBC,0xB8,0x2F,0x2F,0x2F,0x2F,0xB8,0xB8,0xB9,0xB9,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBA,0xBB,0xBA,0xBC,0xBD,0xB8,0xB5,0xB6,0xB7,0xB9,0xB7,0xBA,0xBA,0xBC,0x2F,0xFB,
  TRNP,0x2F,0xBD,0xB9,0xBB,0xBC,0xBC,0xBA,0xBA,0xB9,0xB7,0xB8,0xB7,0xB9,0xBC,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0x2F,0xBC,0xBB,0xBC,0xBC,0xBC,0xBC,0xBC,0xBB,0xBC,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_44 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB7,0xB5,0xB5,0xB5,0xB5,0xB3,0xB3,0xB5,0xB8,0xBB,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xBA,0xB9,0xBA,0xBA,0xB9,0xB9,0xBA,0xB9,0xB9,0xB8,0xBA,0xBD,0x2F,TRNP,TRNP,
  0x2F,0xBB,0xBB,0xBB,0xBB,0xBB,0xBC,0xBC,0xBC,0xBA,0xB9,0xB9,0xB8,0xB8,0x2F,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xBA,0xB8,0xB9,0xB9,0xBB,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,0x2F,0xBC,0xBA,0xBA,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB2,0xB2,0xB5,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB9,0xBB,0xBB,0xB9,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xBB,0xBB,0xBC,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB6,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xBB,0xBA,0xBB,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,0x2F,0xBB,0xB9,0xBB,0xBA,0xBB,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB8,0x2F,0x2F,0x2F,0x2F,0xBB,0xB8,0xBA,0xBB,0xBA,0xBD,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB5,0xB5,0xB5,0xB2,0xB2,0xB2,0xB7,0xBA,0xBC,0xBB,0xBB,0x2F,0xFB,0xFB,
  0x2F,0xB7,0xB5,0xB3,0xB4,0xB4,0xB4,0xB4,0xB4,0xB7,0xBA,0xBC,0xBC,0xBD,0x2F,0xFB,TRNP,
  0x2F,0xBA,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0x2F,0x2F,0xFB,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_45 [] =
{
  17,16,0,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBB,0xB5,0xB4,0xB2,0xB2,0xB2,0xB3,0xB3,0xB3,0xB5,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB8,0xB7,0xB6,0xB6,0xB5,0xB6,0xB6,0xB7,0xB7,0xB9,0xBA,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB8,0xB5,0xB5,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,
  0x2F,0xBB,0xB8,0xB4,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB4,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x2F,0xB9,0xB5,0xB3,0xB5,0xB4,0xB2,0xB2,0xB4,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB5,0xB3,0xB5,0xB6,0xB6,0xB5,0xB5,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB5,0xB2,0xB6,0xB9,0xBB,0xBB,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB2,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBC,0xB5,0xB2,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB8,0xB3,0xB5,0xB4,0xB4,0xB3,0xB1,0xB1,0xB1,0xB2,0xB3,0xB4,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB8,0xB5,0xB6,0xB6,0xB6,0xB5,0xB6,0xB6,0xB6,0xB6,0xB6,0xB8,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_46 [] =
{
  17,16,0,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBB,0xB8,0xB7,0xB5,0xB5,0xB5,0xB5,0xB5,0xB5,0xB8,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xBB,0xB9,0xB7,0xB7,0xB7,0xB7,0xB8,0xB8,0xB9,0xB9,0xB8,0xB8,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB9,0xB6,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,
  0x2F,0xBB,0xB6,0xB9,0xB8,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB9,0xB8,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x2F,0xB9,0xB6,0xB9,0xB8,0xB6,0xB4,0xB2,0xB4,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB9,0xB7,0xB8,0xB7,0xB8,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB6,0xB9,0xB7,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB9,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB9,0xBA,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB6,0xB9,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB6,0xB9,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_47 [] =
{
  17,16,0,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB7,0xB5,0xB4,0xB4,0xB1,0xB1,0xB2,0xB5,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBC,0xB6,0xB6,0xB5,0xB6,0xB6,0xB7,0xB7,0xB9,0xBA,0xBA,0xB8,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xB5,0xB6,0xB5,0xB4,0xB9,0xBB,0xBC,0xBC,0xBC,0xBB,0xB9,0xB8,0xB5,0x2F,TRNP,
  0x2F,0xBA,0xB5,0xB6,0xB4,0xBA,0xBD,0x2F,0x2F,0x2F,0x2F,0x2E,0xBC,0xB8,0xB5,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB5,0xBC,0x2F,0xFB,0xFB,0xFB,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB5,0x2F,0xFB,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB6,0x2F,0xFB,TRNP,0x2F,0xB7,0xB5,0xB7,0xB7,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB6,0xB6,0xB6,0x2F,0xFB,TRNP,0x2F,0xB9,0xB7,0xB9,0xB8,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB6,0xB6,0xB8,0x2F,TRNP,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xBB,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB7,0xB6,0xB5,0xB8,0x2F,0x2F,0x2F,0x2F,0xB9,0xB9,0xB8,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xB5,0xB6,0xB7,0xB6,0xB4,0xB4,0xB4,0xB2,0xB3,0xB7,0xB9,0xB9,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB6,0xB6,0xB6,0xB5,0xB8,0xB9,0xBA,0xBC,0xBB,0xBA,0xB9,0xBA,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0xB8,0xB8,0xB9,0xBA,0xBA,0xBB,0xBC,0xBB,0xBA,0xBA,0xBC,0x2F,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_48 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB9,0xB2,0xB1,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB7,0xB3,0xB3,0xB8,0x2F,0xFB,
  0x2F,0xBA,0xB6,0xB6,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBA,0xB7,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB7,0xB7,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBA,0xB8,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB7,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBA,0xB9,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB8,0xB8,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBB,0xBA,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB6,0xB9,0xB6,0xB4,0xB2,0xB2,0xB7,0xB7,0xBB,0xBB,0xBB,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB7,0xB8,0xB8,0xB8,0xB9,0xB9,0xBA,0xBA,0xBB,0xBB,0xBC,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB6,0xB7,0xBA,0xBA,0xBA,0xBB,0xBC,0xBC,0xBB,0xBB,0xBA,0xBC,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xBB,0xBA,0xBC,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0x2F,0xFB,0xFB,0xFB,0xFB,0x2F,0xBC,0xBB,0xBA,0xBB,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBC,0xBB,0xBA,0xBC,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB3,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBC,0xBB,0xB9,0xBB,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2C,0xBD,0xBB,0xBC,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_49 [] =
{
  7,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB6,0xB4,0xB3,0xB7,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB4,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB6,0xB4,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB4,0xB4,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB4,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB6,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB8,0xB9,0xBB,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_4A [] =
{
  17,16,0,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB6,0xB2,0xB3,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB6,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB7,0xB7,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB7,0xB7,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB8,0xB8,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB6,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB5,0xB5,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB5,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB5,0xB5,0xB9,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB6,0xB5,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xBA,0xBA,0xB9,0xB8,0xB7,0xB6,0xB6,0xB5,0xB5,0xB5,0xB8,0x2F,0xFB,0xFB,
  0x2F,0xBA,0xB8,0xB7,0xB8,0xB9,0xBA,0xBA,0xBC,0xBA,0xB4,0xB7,0xB3,0xB9,0x2F,0xFB,TRNP,
  0x2F,0xBC,0xBB,0xBD,0xBD,0xBC,0xBA,0xBC,0x2C,0xBC,0xBA,0xB9,0x2F,0x2F,0xFB,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_4B [] =
{
  19,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB8,0xB5,0xB5,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xB4,0xB5,0xB5,0xB4,0xB8,0x2F,0xFB,
  0x2F,0xB9,0xBB,0xBC,0xBD,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB6,0xBA,0xB9,0xBD,0xBC,0x2F,0xFB,0xFB,
  0x2F,0xB9,0xBA,0xBB,0xBD,0x2F,0xFB,TRNP,TRNP,0x2F,0xB4,0xB8,0xB9,0xB9,0xBD,0x2F,0xFB,0xFB,TRNP,
  0x2F,0xBA,0xBA,0xBA,0xBD,0x2F,0xFB,TRNP,0x2F,0xB6,0xB5,0xB5,0xB8,0xBB,0x2F,0xFB,0xFB,TRNP,TRNP,
  0x2F,0xB9,0xBA,0xBB,0xBB,0x2F,0xFB,0x2F,0xB6,0xB9,0xB6,0xB7,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xBB,0xBD,0xBC,0x2F,0x2F,0xB7,0xBB,0xBA,0xB9,0xBB,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xBB,0xBD,0x2E,0x2F,0xBB,0xBC,0xBB,0xBB,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xBB,0xBD,0x2C,0x2F,0x2F,0xBB,0xBB,0xBB,0xBB,0xB6,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB9,0xBB,0xBA,0x2F,0xFB,0x2F,0xBD,0xB9,0xBB,0xBA,0xB4,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB9,0xBA,0xBA,0x2F,0xFB,TRNP,0x2F,0xBB,0xBB,0xBA,0xB7,0xB6,0x2F,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB7,0xB9,0xBA,0x2F,0xFB,TRNP,TRNP,0x2F,0xBC,0xB9,0xB7,0xB9,0xB4,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB6,0xB9,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBB,0xB7,0xB8,0xB7,0xB6,0x2F,TRNP,TRNP,
  0x2F,0xB9,0xB9,0xBB,0x2D,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xBC,0xB9,0xBA,0xBB,0xB9,0x2F,TRNP,
  0x2F,0xBD,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_4C [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB3,0xB2,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB6,0xB6,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB7,0xB7,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB7,0xB7,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB6,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB5,0xB5,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB5,0xB6,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB5,0xB5,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB5,0xB5,0xB6,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB5,0xB5,0xB5,0xB5,0xB7,0xB7,0xB7,0xB8,0xB9,0xBA,0xBA,0xB9,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB9,0xB3,0xB4,0xB4,0xB4,0xB4,0xB4,0xB7,0xBA,0xBC,0xBB,0xB9,0xBA,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0xB9,0xB8,0xB8,0xB8,0xB9,0xBA,0xBC,0x2C,0xBD,0xBB,0xBC,0x2F,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_4D [] =
{
  17,16,0,
  TRNP,TRNP,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xB5,0xB6,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0xB6,0xB5,0x2F,TRNP,TRNP,
  0x2F,0xBB,0xB8,0xB7,0xB1,0xB4,0x2F,TRNP,TRNP,0x2F,0xB4,0xB5,0xB9,0xB2,0xBC,0x2F,TRNP,
  0x2F,0xBA,0xB8,0xB5,0xB1,0xB6,0xB1,0x2F,0x2F,0xB4,0xB8,0xB8,0xB8,0xB2,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB6,0xB1,0xB6,0xB4,0xB1,0xB1,0xB7,0xB7,0xB8,0xB9,0xB2,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB5,0xB1,0xB6,0xB5,0xB4,0xB3,0xB7,0xB8,0xB8,0xBA,0xB4,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB1,0xB6,0xB5,0xB5,0xB3,0xB7,0xB8,0xB9,0xBB,0xB4,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB1,0x2F,0xB9,0xB5,0xB5,0xBA,0x2F,0xBA,0xBA,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB4,0xB1,0x2F,0x2F,0xB9,0xB9,0x2F,0x2F,0xBB,0xBB,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB4,0xB1,0x2F,0xFB,0x2F,0x2F,0xFB,0x2F,0xBA,0xBB,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB4,0xB3,0x2F,0xFB,TRNP,0xFB,0xFB,0x2F,0xBA,0xBD,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB4,0xB3,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBA,0xBD,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB3,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBA,0x2D,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xBB,0xB8,0xB9,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBB,0x2E,0xB8,0xBC,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_4E [] =
{
  17,16,0,
  TRNP,TRNP,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB5,0xB7,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB4,0xB4,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB6,0xB4,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB8,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB6,0xB6,0xB4,0x2F,TRNP,TRNP,TRNP,0x2F,0xB9,0xB7,0xB7,0xBB,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB5,0xB8,0xB7,0xB4,0x2F,TRNP,TRNP,0x2F,0xB9,0xB3,0xB7,0xBB,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB6,0xB8,0xB8,0xB8,0xB4,0x2F,TRNP,0x2F,0xB9,0xB3,0xB6,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xB8,0xB8,0xB9,0xB7,0xB7,0xB4,0x2F,0x2F,0xB9,0xB4,0xB6,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB6,0xB6,0xB7,0xB8,0xB7,0xB8,0xB7,0xB4,0x2F,0xB9,0xB5,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB7,0xB9,0x2F,0xBA,0xB8,0xB9,0xB7,0xB8,0xB7,0xB5,0xB7,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB9,0xBA,0x2F,0x2F,0xBB,0xB9,0xB6,0xB6,0xB8,0xB7,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xBA,0xBB,0x2F,0xFB,0x2F,0xBC,0xB7,0xB6,0xB8,0xB7,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xBB,0xBA,0xBA,0xBC,0x2F,0xFB,TRNP,0x2F,0xBA,0xB8,0xB6,0xB5,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xBB,0xB9,0xBB,0xBC,0x2F,0xFB,TRNP,TRNP,0x2F,0xBA,0xB8,0xB6,0xB4,0xBB,0x2F,0xFB,
  0x2F,0xBC,0xBC,0xBC,0xBD,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBC,0xB9,0xB9,0x2F,0xFB,0xFB,
  0x2F,0x2D,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_4F [] =
{
  19,16,0,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB7,0xB5,0xB4,0xB4,0xB1,0xB1,0xB2,0xB5,0xB7,0xB7,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBC,0xB6,0xB6,0xB5,0xB6,0xB6,0xB7,0xB7,0xB9,0xBA,0xBA,0xB8,0xB6,0xBC,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xB5,0xB6,0xB5,0xB4,0xB9,0xBB,0xBC,0xBC,0xBC,0xBB,0xB9,0xB8,0xB5,0xB6,0x2F,0xFB,TRNP,
  0x2F,0xBA,0xB5,0xB6,0xB4,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xB8,0xB5,0xB7,0xBA,0x2F,TRNP,
  0x2F,0xB8,0xB5,0xB6,0xB5,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0x2F,0xB7,0xB6,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB5,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB5,0xB6,0xB6,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB6,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB6,0xB6,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB8,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB6,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB8,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB7,0xB6,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB8,0xB7,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB5,0xB6,0xB7,0xB6,0xB4,0xB4,0xB4,0xB2,0xB3,0xB7,0xB9,0xB9,0xB8,0xB8,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBC,0xB6,0xB6,0xB6,0xB5,0xB8,0xB9,0xBA,0xBC,0xBB,0xBA,0xB9,0xB9,0xBC,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB8,0xB8,0xB9,0xBA,0xBA,0xBB,0xBC,0xBB,0xBA,0xBA,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_50 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB7,0xB4,0xB3,0xB3,0xB4,0xB4,0xB4,0xB4,0xB5,0xB5,0xB7,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB7,0xB8,0xBA,0xBA,0xBA,0xB9,0xB9,0xB8,0xB7,0xB8,0xB7,0xB9,0x2F,TRNP,TRNP,
  0x2F,0xBB,0xBA,0xBB,0xBC,0xBC,0xBC,0xBC,0xBB,0xBB,0xBA,0xB8,0xB7,0xB9,0xBC,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB3,0xB4,0xB4,0xB6,0xB4,0xB4,0xB7,0xB7,0xB8,0xBB,0xB9,0xB9,0xBC,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB8,0xB8,0xB8,0xB9,0xB9,0xBA,0xBA,0xBB,0xBB,0xBC,0xBB,0x2F,0xFB,0xFB,
  0x2F,0xB9,0xB7,0xB7,0xBA,0xBA,0xBB,0xBC,0xBC,0xBC,0xBC,0xBC,0x2F,0x2F,0xFB,0xFB,TRNP,
  0x2F,0xB8,0xB6,0xB7,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  0x2F,0xB8,0xB6,0xB6,0xB9,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB5,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB7,0xB4,0xB4,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_51 [] =
{
  19,18,0,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB7,0xB5,0xB4,0xB4,0xB1,0xB1,0xB2,0xB5,0xB7,0xB7,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBC,0xB6,0xB6,0xB5,0xB6,0xB6,0xB7,0xB7,0xB9,0xBA,0xBA,0xB8,0xB6,0xBC,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xB5,0xB6,0xB5,0xB4,0xB9,0xBB,0xBC,0xBC,0xBC,0xBB,0xB9,0xB8,0xB5,0xB6,0x2F,0x2F,TRNP,
  0x2F,0xBA,0xB5,0xB6,0xB4,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xB8,0xB5,0xB7,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB5,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0x2F,0xB7,0xB6,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB5,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB5,0xB6,0xB6,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB6,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB6,0xB6,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB8,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB6,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB8,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB7,0xB6,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB8,0xB8,0xB7,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB5,0xB6,0xB7,0xB6,0xB4,0xB4,0xB4,0xB2,0xB3,0xB7,0xB9,0xB9,0xB8,0xB8,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBC,0xB6,0xB6,0xB6,0xB5,0xB8,0xB9,0xBA,0xBC,0xBB,0xBA,0xB9,0xB9,0xBC,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB8,0xB8,0xB9,0xBA,0xBA,0xBB,0xBC,0xBB,0xBA,0xBA,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBB,0xBB,0xB9,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0x2F,0xBC,0xBC,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP
};

static const unsigned char red_char_52 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB6,0xB3,0xB4,0xB4,0xB1,0xB1,0xB1,0xB2,0xB4,0xB5,0xB6,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB7,0xB8,0xB7,0xB5,0xB6,0xB6,0xB7,0xB7,0xB8,0xB9,0xB7,0xBB,0x2F,TRNP,TRNP,
  0x2F,0xBA,0xBA,0xBA,0xBA,0xB9,0xB8,0xB9,0xB9,0xB9,0xBA,0xB8,0xB8,0xB7,0x2F,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBA,0xB7,0xB7,0xBB,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBA,0xB5,0xB8,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB4,0xB4,0xB4,0xB4,0xB1,0xB2,0xB3,0xB4,0xB4,0xB5,0xB4,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB8,0xB7,0xB7,0xB8,0xB7,0xB5,0xB5,0xB6,0xB5,0xB2,0xB6,0xBB,0x2F,0xFB,
  0x2F,0xB9,0xB8,0xB8,0xB8,0xBB,0xBB,0xB9,0xB9,0xB5,0xB6,0xB5,0xB2,0xBB,0x2F,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB7,0xB9,0x2F,0x2F,0x2F,0x2D,0xBB,0xB8,0xB5,0xB2,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB7,0xB9,0x2F,0xFB,0xFB,0xFB,0x2F,0xB9,0xB4,0xB2,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB6,0xB8,0x2F,0xFB,TRNP,TRNP,0x2F,0xB8,0xB4,0xB2,0xB4,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB7,0xB8,0x2F,0xFB,TRNP,TRNP,0x2F,0xB8,0xB3,0xB3,0xB3,0xB7,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xB9,0xBA,0x2F,0xFB,TRNP,TRNP,0x2F,0xBA,0xB8,0xB7,0xB8,0xB9,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_53 [] =
{
  17,16,0,
  TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xBC,0xB7,0xB6,0xB4,0xB4,0xB2,0xB3,0xB3,0xB3,0xB7,0xB9,0x2F,0xFB,TRNP,
  TRNP,0x2F,0xBA,0xB9,0xBA,0xB8,0xB8,0xB6,0xB7,0xBA,0xB9,0xB7,0xB9,0xBA,0x2F,0xFB,TRNP,
  0x2F,0xBA,0xB5,0xB8,0xB8,0xBB,0xBA,0xBA,0xBA,0xBB,0xBB,0xBB,0xB9,0xBB,0x2F,0xFB,TRNP,
  0x2F,0xB8,0xB5,0xB7,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,
  0x2F,0xB8,0xB4,0xB6,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,
  0x2F,0xBA,0xB6,0xB5,0xB5,0xB4,0xB3,0xB2,0xB1,0xB2,0xB2,0xB4,0xBA,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBA,0xB5,0xB5,0xB6,0xB7,0xBA,0xBA,0xB9,0xB7,0xB6,0xB8,0xBA,0x2F,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xBB,0xB9,0xB9,0xBA,0xBC,0xBB,0xBB,0xB9,0xB6,0xB7,0xB8,0xBA,0x2F,TRNP,
  TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBA,0xB8,0xB8,0xB6,0x2F,0xFB,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBA,0xB7,0xB7,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB1,0xB1,0xB1,0xB1,0xB1,0xB3,0xB4,0xB9,0xB7,0xB6,0xB8,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB8,0xB2,0xB3,0xB5,0xB5,0xB5,0xB8,0xB8,0xB8,0xB7,0xB5,0xBA,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xB9,0xB7,0xB7,0xB8,0xB9,0xB9,0xBA,0xB9,0xBA,0xBB,0xBA,0x2F,0xFB,0xFB,TRNP,
  TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP
};

static const unsigned char red_char_54 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB7,0xB5,0xB5,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB3,0xB4,0xB3,0xB6,0x2F,0xFB,
  0x2F,0xBA,0xBA,0xBA,0xBB,0xBB,0xB9,0xB9,0xB6,0xB4,0xB7,0xB9,0xB9,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBB,0xBB,0xBB,0xB9,0xB9,0xB6,0xB4,0xBB,0xBB,0xBB,0xBB,0xBB,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB7,0xB6,0xB8,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0x2F,0xB8,0xB6,0xB6,0xB8,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB5,0xB6,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB5,0xB4,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB4,0xB4,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB5,0xB3,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB4,0xB2,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB3,0xB2,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB1,0xB2,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB6,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_55 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB7,0xB4,0xB5,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB6,0xB3,0xB4,0xB7,0x2F,0xFB,
  0x2F,0xB7,0xB7,0xB9,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB7,0xB5,0xB7,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xB6,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xB6,0xB6,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB6,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB7,0xB6,0xB5,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB6,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB7,0xB6,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB7,0xB5,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB7,0xB5,0xB6,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xB5,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB8,0xBB,0xB8,0x2F,0x2F,0x2F,0x2F,0xB7,0xB5,0xB5,0xB5,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xB3,0xB8,0xBB,0xBC,0xB7,0xB1,0xB1,0xB3,0xB4,0xB7,0xB6,0xB5,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBA,0xB7,0xBB,0xBC,0xBB,0xB7,0xB4,0xB7,0xB5,0xB8,0xB6,0xBA,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBD,0x2C,0xBB,0xBB,0xB8,0xBB,0xBA,0xBD,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_56 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB4,0xB3,0xB4,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB5,0xB4,0xB4,0xB8,0x2F,0xFB,
  0x2F,0xB6,0xB7,0xB8,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB9,0xB7,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB7,0xB7,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xB8,0xB7,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB7,0xB7,0xB7,0xB6,0x2F,TRNP,TRNP,0x2F,0xB7,0xB7,0xB7,0xB7,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBA,0xB8,0xB6,0xB5,0x2F,0xFB,TRNP,0x2F,0xB6,0xB6,0xB5,0xBA,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xB8,0xB7,0xB7,0xB7,0x2F,0x2F,0xB5,0xB5,0xB5,0xB4,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xBA,0xB7,0xB7,0xB8,0x2F,0x2F,0xB5,0xB6,0xB5,0xBA,0x2F,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB8,0xB9,0xB9,0xB3,0xB3,0xB5,0xB6,0xB5,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xBA,0xB8,0xB8,0xB5,0xB5,0xB6,0xB6,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB5,0xB5,0xB5,0xB6,0xB7,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB5,0xB4,0xB5,0xB6,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB5,0xB4,0xB4,0xB6,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB8,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_57 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB7,0xB3,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB4,0xB7,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB7,0x2F,0xFB,
  0x2F,0xBA,0xB4,0xB8,0x2F,0xFB,TRNP,0x2F,0x2F,TRNP,TRNP,0x2F,0xB9,0xB6,0xB7,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB8,0x2F,0xFB,0x2F,0xB5,0xB5,0x2F,TRNP,0x2F,0xB9,0xB7,0xB8,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB8,0x2F,0x2F,0xB4,0xBA,0xBA,0xB4,0x2F,0x2F,0xB9,0xB7,0xB8,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB8,0x2F,0xB3,0xB8,0xBA,0xB9,0xB9,0xB4,0x2F,0xB9,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB3,0xB3,0xB6,0xB8,0xBB,0xB9,0xBB,0xB7,0xB4,0xB8,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB1,0xB4,0xB5,0xB6,0xB9,0xBB,0xBB,0xB7,0xB7,0xB7,0xB7,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB1,0xB0,0xB3,0xB6,0xB9,0x2F,0x2F,0xBC,0xB9,0xB7,0xB6,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB0,0xB0,0xB3,0xB9,0x2F,0xFB,0xFB,0x2F,0xBC,0xB7,0xB5,0xB8,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB6,0xBC,0x2F,0xFB,0xFB,TRNP,TRNP,0x2F,0xBC,0xB9,0xBA,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_58 [] =
{
  17,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB4,0xB3,0xB4,0xB4,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0xB2,0xB3,0xB4,0xB6,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB9,0xB9,0xB8,0x2F,TRNP,TRNP,0x2F,0xB4,0xB4,0xB5,0xB7,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBA,0xB8,0xB9,0xBC,0xB8,0x2F,0x2F,0xB4,0xB7,0xB5,0xB6,0xBA,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0xBA,0xB9,0xBC,0xBC,0xB8,0xB6,0xB6,0xB7,0xB5,0xB9,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xBB,0xBC,0xBC,0xBA,0xBA,0xB4,0xB7,0xB8,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xBD,0xBC,0xBA,0xB8,0xB4,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB9,0xB9,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xBD,0xB9,0xB9,0xB8,0xB7,0xBA,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xBB,0xB9,0xB9,0xBA,0xBA,0xB7,0xB7,0xB8,0x2F,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xBA,0xB9,0xB9,0xBA,0xBB,0xBB,0xB6,0xB7,0xB5,0xB9,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBA,0xB8,0xBA,0xB9,0xBB,0x2F,0x2F,0xBB,0xB7,0xB5,0xB6,0xBA,0x2F,TRNP,TRNP,
  0x2F,0xB8,0xB7,0xB9,0xB9,0xBB,0x2F,0xFB,0xFB,0x2F,0xBB,0xB7,0xB5,0xB7,0xB9,0x2F,TRNP,
  0x2F,0xBB,0xBB,0xBC,0xBC,0x2F,0xFB,0xFB,TRNP,TRNP,0x2F,0xBB,0xB9,0xB9,0xBC,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_59 [] =
{
  18,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB4,0xB3,0xB4,0xB4,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0xB2,0xB3,0xB4,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB9,0xB9,0xB8,0x2F,TRNP,TRNP,0x2F,0xB4,0xB4,0xB5,0xB7,0xB9,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBA,0xB8,0xB9,0xBC,0xB8,0x2F,0x2F,0xB4,0xB7,0xB5,0xB6,0xBA,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xBA,0xB9,0xBC,0xBC,0xB8,0xB6,0xB6,0xB7,0xB5,0xB9,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xBB,0xBC,0xBC,0xBB,0xBA,0xB4,0xB7,0xB8,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xBD,0xBC,0xB9,0xB8,0xB4,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBC,0xBA,0xB7,0xB7,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBC,0xB9,0xB6,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2C,0xB8,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2B,0xB8,0xB4,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2A,0xB8,0xB4,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xB7,0xB4,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xBB,0xB8,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_5A [] =
{
  16,16,0,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB9,0xB7,0xB3,0xB3,0xB3,0xB2,0xB4,0xB4,0xB6,0xB3,0xB2,0xB3,0xB4,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xB7,0xB9,0xBA,0xB7,0xB6,0xB6,0xB6,0xB6,0xB4,0xB5,0xB7,0x2F,0xFB,
  0x2F,0xBB,0xB9,0xBB,0xBB,0xBB,0xBA,0xBB,0xBA,0xBA,0xB7,0xB5,0xB6,0xBA,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBA,0xB6,0xB7,0xB5,0xB9,0x2F,0xFB,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0x2F,0xB7,0xB8,0xB4,0xB7,0xB8,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB8,0xB8,0xB8,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB6,0xB8,0xB9,0xB9,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB6,0xB8,0xB8,0xB9,0xB8,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xB7,0xB8,0xB9,0xB9,0xBA,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xB7,0xB8,0xB9,0xB9,0xBA,0xBB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB8,0xB8,0xBA,0xBA,0xB9,0xBB,0xBB,0xB9,0xB8,0xB5,0xB1,0xB1,0xB6,0x2F,0xFB,
  0x2F,0xBA,0xBA,0xB9,0xB9,0xBB,0xBB,0xB9,0xB8,0xB5,0xB5,0xB3,0xB2,0xB8,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBC,0xBC,0xBB,0xBC,0xBC,0xBB,0xBB,0xB9,0xB8,0xB9,0xBC,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_61 [] =
{
  16,13,3,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0xB7,0xB6,0xB2,0xB2,0xB3,0xBA,0x2F,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xB8,0xB9,0xB8,0xBA,0xBB,0xB5,0xB7,0xBC,0x2F,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xBA,0xB8,0xB6,0xBA,0x2F,0x2F,0xB9,0xB6,0xB7,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,0x2F,0xB8,0xB6,0xB7,0x2F,0x2F,0x2F,0xB9,0xB6,0xB8,0xB9,0x2F,0xFB,
  TRNP,TRNP,0x2F,0xBA,0xB5,0xB5,0xBA,0x2F,0xB4,0xB4,0xB7,0xB6,0xB7,0xBA,0x2F,0xFB,
  TRNP,TRNP,0x2F,0xB8,0xB5,0xB6,0x2F,0x2F,0xB9,0xBB,0xB9,0xB6,0xB8,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xBA,0xB5,0xB4,0xBA,0x2F,0x2F,0x2F,0x2F,0xB9,0xB7,0xB7,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xB7,0xB2,0xB3,0x2F,0xFB,0xFB,0xFB,0x2F,0xBA,0xB7,0xB6,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB2,0xBA,0x2F,0xFB,TRNP,TRNP,0x2F,0xBA,0xB7,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB8,0xB7,0x2F,0xFB,0xFB,TRNP,TRNP,0x2F,0xBB,0xBA,0xB9,0xBB,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_62 [] =
{
  15,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB7,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB4,0xB6,0xBA,0x2F,TRNP,TRNP,
  0x2F,0xBA,0xBC,0xB9,0xB9,0xB6,0xB8,0xB6,0xB8,0xB6,0xB6,0xB5,0xBA,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB4,0xB3,0xB4,0xB6,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB3,0xB3,0xB5,0xB6,0x2F,0xFB,
  0x2F,0xB7,0xB2,0xB1,0xB1,0xB2,0xB1,0xB1,0xB3,0xB5,0xB3,0xB3,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB1,0xB2,0xB9,0xB6,0xB6,0xB9,0xB9,0xB3,0xB7,0x2F,0x2F,0xFB,
  0x2F,0xBA,0xBA,0xB3,0xB1,0x2F,0x2F,0x2F,0x2F,0xB5,0xB3,0xB7,0xB6,0x2F,0xFB,
  0x2F,0xB9,0xBA,0xB4,0xB1,0x2F,0x2F,0x2F,0x2F,0xB3,0xB3,0xB5,0xB6,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB5,0xB4,0xB1,0xB1,0xB1,0xB3,0xB5,0xB3,0xB3,0xBA,0x2F,0xFB,
  0x2F,0xBB,0xBC,0xBB,0xB9,0xB6,0xB6,0xB6,0xB9,0xB9,0xB7,0xBA,0x2F,0xFB,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_63 [] =
{
  15,13,3,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBB,0xB8,0xB8,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0x2F,0xFB,
  TRNP,0x2F,0xBB,0xB6,0xBC,0xBC,0xBC,0xBC,0xB8,0xBA,0xB8,0xB9,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB8,0xB9,0xBC,0xBD,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xBB,0xB8,0xB9,0xBC,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x2F,0xB9,0xB8,0xBA,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB8,0xBA,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xB8,0xBB,0xBC,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xB8,0xBB,0xBC,0xB8,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xBC,0xBB,0xBC,0xBB,0xB4,0xB2,0xB4,0xB2,0xB3,0xB2,0xB6,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0x2C,0xBB,0xBB,0xB8,0xBB,0xBA,0xBA,0xBA,0xB9,0x2F,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_64 [] =
{
  16,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2D,0xB8,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB2,0xB4,0xBA,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xBA,0xB9,0xB9,0xB9,0xB8,0xB8,0xB9,0xB6,0xB6,0xB5,0xBB,0x2F,TRNP,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB5,0xB4,0xB6,0x2F,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,0x2F,0xB5,0xB2,0xB6,0xBB,0x2F,TRNP,
  0x2F,0xB8,0xB5,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,0x2F,0xB5,0xB2,0xB4,0xB9,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,0x2F,0xB5,0xB2,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB7,0xB9,0x2F,0xFB,TRNP,TRNP,0x2F,0xB4,0xB2,0xB3,0xBB,0x2F,0xFB,
  0x2F,0xB8,0xB6,0xB6,0xB8,0x2F,0x2F,0x2F,0x2F,0xB4,0xB4,0xB2,0xB7,0x2F,0xFB,0xFB,
  0x2F,0xB8,0xB7,0xB5,0xB4,0xB2,0xB1,0xB1,0xB4,0xB5,0xB3,0xB7,0xBB,0x2F,0xFB,TRNP,
  0x2F,0xBA,0xB9,0xB9,0xB8,0xB8,0xB8,0xB8,0xB9,0xB9,0xBA,0x2F,0x2F,0xFB,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_65 [] =
{
  15,13,3,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB9,0xB4,0xB6,0xB3,0xB3,0xB4,0xB4,0xB3,0xB8,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB7,0xB6,0xB6,0xBA,0xBB,0xBA,0xBC,0xBC,0xB9,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xB9,0xB5,0xB5,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xBA,0xB6,0xB5,0xB5,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB5,0xB5,0xB5,0xB5,0xB4,0xB4,0xB4,0xB2,0xB2,0xB9,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB6,0xB5,0xB6,0xBA,0xBC,0xBB,0xBC,0xBA,0xB9,0xBB,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB5,0xB4,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0x2F,0xB7,0xB2,0xB3,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB9,0xB3,0xB5,0xB3,0xB2,0xB2,0xB2,0xB3,0xB4,0xB7,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0xBA,0xB8,0xB9,0xB9,0xBA,0xB9,0xBA,0xBA,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_66 [] =
{
  13,13,3,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBA,0xB4,0xB1,0xB1,0xB1,0xB2,0xB7,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xBA,0xB6,0xB9,0xB9,0xB9,0xB8,0xB8,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB8,0xBA,0xB5,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xBB,0xB8,0xB8,0xB5,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,0xFB,
  0x2F,0xB9,0xB7,0xB5,0xB4,0xB1,0xB1,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB4,0xB4,0xB9,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB7,0xB5,0xB9,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB3,0xB8,0x2F,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB2,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xBA,0xB7,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_67 [] =
{
  17,13,3,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBB,0xB8,0xB8,0xB5,0xB4,0xB2,0xB2,0xB2,0xB2,0xB4,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB8,0xB9,0xBC,0xBD,0xBC,0xBC,0xB8,0xBA,0xB8,0xB9,0xB9,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB8,0xB9,0xBC,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xBB,0xB7,0xB8,0xB9,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x2F,0xBA,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xBA,0xB8,0xB8,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB6,0xB1,0xB1,0xB8,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB8,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xB2,0xB1,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xB3,0xB8,0xBB,0xBC,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB2,0xB1,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBC,0xB7,0xBB,0xBC,0xB7,0xB2,0xB1,0xB2,0xB3,0xB8,0xB2,0xB1,0xB9,0x2F,0xFB,
  TRNP,TRNP,0x2F,0x2F,0xBD,0x2C,0xBB,0xBB,0xB8,0xBB,0xBA,0xBA,0xB7,0xB7,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_68 [] =
{
  16,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB8,0xB4,0xB4,0xB7,0x2F,0xFB,TRNP,TRNP,0x2F,0xB7,0xB2,0xB2,0xB7,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xB8,0xB8,0x2F,0xFB,TRNP,TRNP,0x2F,0xB8,0xB6,0xB5,0xBA,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,0x2F,0xB8,0xB5,0xB4,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB8,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0xB8,0xB5,0xB2,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB8,0xB8,0xB8,0xB6,0xB4,0xB2,0xB2,0xB3,0xB6,0xB5,0xB2,0xB7,0x2F,0xFB,
  0x2F,0xBA,0xB7,0xB7,0xBA,0xBA,0xBA,0xB9,0xB9,0xB9,0xB9,0xB5,0xB2,0xB7,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB7,0xBA,0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xB4,0xB2,0xB7,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB6,0xBA,0x2F,0xFB,0xFB,0xFB,0x2F,0xB9,0xB4,0xB2,0xB7,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB7,0xB9,0x2F,0xFB,TRNP,TRNP,0x2F,0xB8,0xB3,0xB3,0xB7,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xB9,0xBB,0x2F,0xFB,TRNP,TRNP,0x2F,0xBA,0xB8,0xB7,0xBA,0x2F,0xFB,
  0x2F,0x2D,0x2F,0x2F,0x2D,0x2F,0xFB,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_69 [] =
{
  7,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB7,0xB3,0xB3,0xB8,0x2F,0xFB,
  0x2F,0xB9,0xB9,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xB8,0xBA,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xBA,0xBA,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xBA,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xBB,0xB9,0xBB,0x2F,0xFB,
  0x2F,0xB8,0xB9,0xBB,0xBB,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB9,0xBA,0xBA,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_6A [] =
{
  12,13,3,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB7,0xB2,0xB4,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB6,0xB9,0xBC,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xB8,0xBA,0xBB,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xBA,0xBB,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB9,0xBA,0xBB,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB9,0xB8,0xBA,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xB8,0xB6,0xB9,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0xB9,0xBB,0xB9,0xB8,0xBA,0x2F,0xFB,
  0x2F,0xB6,0xB3,0xB4,0xB6,0xB6,0xB9,0xB9,0xBA,0x2F,0xFB,0xFB,
  0x2F,0xB9,0xBB,0xB9,0xB9,0xBB,0xBB,0xBB,0x2F,0x2F,0xFB,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP
};

static const unsigned char red_char_6B [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,
  0x2F,0xB6,0xB2,0xB1,0xB5,0x2F,0xFB,TRNP,0x2F,0xB1,0xB1,0xB1,0xB1,0xB8,0x2F,0xFB,TRNP,
  0x2F,0xB7,0xB6,0xB3,0xB4,0x2F,0xFB,0x2F,0xB1,0xB4,0xB6,0xB5,0xBA,0x2F,0xFB,0xFB,TRNP,
  0x2F,0xB6,0xB3,0xB4,0xB6,0x2F,0x2F,0xB2,0xB4,0xB4,0xB4,0xB8,0x2F,0xFB,0xFB,TRNP,TRNP,
  0x2F,0xB7,0xB2,0xB1,0xB7,0x2F,0xB2,0xB5,0xB4,0xB3,0xB9,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB3,0xB2,0xB4,0xB5,0xB6,0xB7,0xB4,0xB4,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB3,0xB2,0xB7,0x2F,0xB9,0xB4,0xB3,0xB3,0xB2,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB7,0xB4,0xB2,0xB7,0x2F,0x2F,0xB8,0xB3,0xB2,0xB3,0xB5,0x2F,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB5,0xB2,0xB6,0x2F,0xFB,0x2F,0xB8,0xB2,0xB3,0xB8,0xB4,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB6,0xB5,0xB3,0xB6,0x2F,0xFB,TRNP,0x2F,0xB7,0xB4,0xB8,0xB7,0xB5,0x2F,TRNP,TRNP,
  0x2F,0xB9,0xB8,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,0x2F,0xBB,0xBC,0xBA,0xBB,0xB6,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_6C [] =
{
  12,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB4,0xB2,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBC,0xB9,0xB6,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xBA,0xBA,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xBB,0xBA,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xB8,0xB9,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBA,0xB8,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB9,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB9,0xB6,0xB8,0xBB,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB8,0xB9,0xB9,0xB2,0xB3,0xB4,0xB3,0xB6,0x2F,0xFB,
  TRNP,0x2F,0x2F,0xBB,0xBB,0xB7,0xB9,0xB9,0xB8,0xB9,0x2F,0xFB,
  TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_6D [] =
{
  17,13,3,
  TRNP,TRNP,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xB5,0xB1,0xB6,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0xB4,0xB1,0xB3,0x2F,TRNP,TRNP,
  0x2F,0xB8,0xB2,0xB1,0xB5,0xB6,0x2F,TRNP,TRNP,0x2F,0xB5,0xB8,0xB4,0xB6,0xB8,0x2F,TRNP,
  0x2F,0xB7,0xB3,0xB3,0xB6,0xBB,0xB7,0x2F,0x2F,0xB3,0xB9,0xB7,0xB6,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xB8,0xB3,0xB5,0xB8,0xBB,0xBB,0xB4,0xB4,0xB5,0xB7,0xB5,0xB7,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xB6,0xB3,0xB5,0xB6,0xBC,0xBB,0xBA,0xB9,0xB5,0xB6,0xB4,0xB8,0xBA,0xBC,0x2F,0xFB,
  0x2F,0xB6,0xB3,0xB4,0xB7,0xBC,0xBB,0xBA,0xB8,0xB6,0xB5,0xB3,0xBA,0xBA,0x2A,0x2F,0xFB,
  0x2F,0xB6,0xB4,0xB3,0xB8,0x2F,0xBC,0xBA,0xB6,0xB9,0x2F,0xB7,0xBA,0xBB,0xBB,0x2F,0xFB,
  0x2F,0xB5,0xB4,0xB4,0xB7,0x2F,0x2F,0xBA,0xB9,0x2F,0x2F,0xB8,0xBA,0xBA,0xBB,0x2F,0xFB,
  0x2F,0xB5,0xB3,0xB3,0xB7,0x2F,0xFB,0x2F,0x2F,0xFB,0x2F,0xB8,0xBB,0xB9,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB8,0xB8,0xB9,0x2F,0xFB,TRNP,0xFB,0xFB,0x2F,0xBA,0xBC,0xBB,0xBA,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_6E [] =
{
  17,13,3,
  TRNP,TRNP,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB1,0xB1,0xBA,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB0,0xB1,0xB8,0x2F,0xFB,
  0x2F,0xB8,0xB4,0xB5,0xB4,0xBA,0x2F,TRNP,TRNP,TRNP,0x2F,0xB6,0xB0,0xB4,0xB8,0x2F,0xFB,
  0x2F,0xB9,0xB6,0xB5,0xB5,0xB6,0xBA,0x2F,TRNP,TRNP,0x2F,0xB6,0xB0,0xB5,0xB9,0x2F,0xFB,
  0x2F,0xB9,0xB5,0xB5,0xB4,0xB6,0xB6,0xBA,0x2F,TRNP,0x2F,0xB7,0xB0,0xB4,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xBA,0x2F,0x2F,0xB7,0xB0,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB6,0xB5,0xB4,0xB6,0xB6,0xB4,0xB2,0xBA,0x2F,0xB6,0xB0,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB6,0xB4,0xB7,0x2F,0xBA,0xB2,0xB2,0xB4,0xB4,0xB2,0xB0,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB3,0xB8,0x2F,0x2F,0xBA,0xB2,0xB5,0xB4,0xB2,0xB0,0xB3,0xB9,0x2F,0xFB,
  0x2F,0xBB,0xB5,0xB3,0xB8,0x2F,0xFB,0x2F,0xBA,0xB3,0xB2,0xB2,0xB0,0xB2,0xBB,0x2F,0xFB,
  0x2F,0xBB,0xB9,0xB8,0xBA,0x2F,0xFB,TRNP,0x2F,0x2F,0xBA,0xB8,0xB6,0xB8,0x2F,0xFB,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_6F [] =
{
  18,13,3,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB9,0xB3,0xB1,0xB1,0xB1,0xB1,0xB1,0xB4,0xB9,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBB,0xB1,0xB5,0xB5,0xB8,0xB8,0xBB,0xBB,0xBA,0xB6,0xB7,0xB8,0xBB,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xB2,0xB3,0xB5,0xBB,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xB7,0xB8,0xB5,0x2F,0xFB,TRNP,
  0x2F,0xBA,0xB4,0xB5,0xB8,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0x2F,0xB9,0xB8,0xB6,0xBA,0x2F,TRNP,
  0x2F,0xB8,0xB4,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xBA,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB4,0xB4,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xBB,0xBB,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB4,0xB3,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xBB,0xBB,0xBA,0x2F,0xFB,
  0x2F,0x2F,0xB2,0xB2,0xB3,0xB5,0x2F,0x2F,0x2F,0x2F,0x2F,0xB6,0xB9,0xBA,0xBA,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBB,0xB7,0xB2,0xB5,0xB1,0xB1,0xB1,0xB3,0xB4,0xB8,0xBA,0xB8,0xBC,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB9,0xB9,0xB8,0xB7,0xB9,0xBC,0xBA,0xBB,0xBB,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_70 [] =
{
  15,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB7,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB4,0xB6,0xBA,0x2F,TRNP,TRNP,
  0x2F,0xBA,0xBC,0xB9,0xB9,0xB6,0xB8,0xB6,0xB8,0xB6,0xB6,0xB5,0xBA,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB4,0xB3,0xB4,0xB6,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB3,0xB3,0xB5,0xB6,0x2F,0xFB,
  0x2F,0xB7,0xB2,0xB1,0xB1,0xB2,0xB1,0xB1,0xB3,0xB5,0xB3,0xB3,0xBA,0x2F,0xFB,
  0x2F,0xB9,0xB7,0xB1,0xB2,0xB9,0xB6,0xB6,0xB9,0xB9,0xB7,0xBA,0x2F,0xFB,0xFB,
  0x2F,0xBA,0xBA,0xB3,0xB1,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  0x2F,0xB9,0xBA,0xB4,0xB3,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,
  0x2F,0xBA,0xB8,0xB5,0xB4,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xBB,0xBC,0xBB,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_71 [] =
{
  18,15,3,
  TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB9,0xB3,0xB1,0xB1,0xB1,0xB1,0xB1,0xB4,0xB9,0x2F,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xBB,0xB1,0xB5,0xB5,0xB8,0xB8,0xBB,0xBB,0xBA,0xB6,0xB7,0xB8,0xBB,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xB2,0xB3,0xB5,0xBB,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xB7,0xB8,0xB5,0x2F,0xFB,TRNP,
  0x2F,0xBA,0xB4,0xB5,0xB8,0x2F,0xFB,0xFB,0xFB,0xFB,0xFB,0x2F,0xB9,0xB8,0xB6,0xBA,0x2F,TRNP,
  0x2F,0xB8,0xB4,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xBA,0xB9,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xBB,0xBB,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB5,0xB8,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xBB,0xBB,0xBA,0x2F,0xFB,
  TRNP,0x2F,0xB8,0xB8,0xB5,0xB9,0x2F,0x2F,0x2F,0x2F,0x2F,0xB6,0xB9,0xBA,0xBA,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBB,0xB9,0xB8,0xB5,0xB6,0xB1,0xB1,0xB3,0xB6,0xB8,0xBA,0xB8,0xBC,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xB9,0xB9,0xB8,0xB7,0xB9,0xBC,0xBA,0xBB,0xBB,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB8,0xBB,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0x2F,0xBA,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_72 [] =
{
  16,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,
  0x2F,0xB8,0xB1,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xBA,0x2F,TRNP,TRNP,
  0x2F,0xBA,0xB8,0xB9,0xB8,0xB9,0xB9,0xB9,0xB8,0xB7,0xB7,0xB4,0xB2,0xBA,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB8,0xB5,0xB3,0xB6,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB8,0xB4,0xB5,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB3,0xB2,0xB3,0xB3,0xB5,0x2F,0xFB,0xFB,
  0x2F,0xB8,0xB4,0xB6,0xB6,0xB8,0xBA,0xBA,0xB9,0xB7,0xB3,0xB3,0xB4,0x2F,0xFB,TRNP,
  0x2F,0xB7,0xB4,0xB5,0xB5,0x2F,0x2F,0x2F,0x2F,0xBA,0xB2,0xB3,0xB4,0xB7,0x2F,TRNP,
  0x2F,0xB6,0xB5,0xB4,0xB6,0x2F,0xFB,0xFB,0xFB,0x2F,0xB2,0xB3,0xB3,0xB8,0x2F,0xFB,
  0x2F,0xB6,0xB5,0xB4,0xB6,0x2F,0xFB,TRNP,TRNP,0x2F,0xB3,0xB2,0xB2,0xB6,0x2F,0xFB,
  0x2F,0xB9,0xBA,0xBA,0xB9,0x2F,0xFB,TRNP,TRNP,0x2F,0xB8,0xBA,0xB9,0xB9,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_73 [] =
{
  16,13,3,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  TRNP,0x2F,0xB6,0xB3,0xB2,0xB2,0xB2,0xB2,0xB4,0xB6,0xB4,0xB7,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xBB,0xB4,0xB4,0xB8,0xBB,0xBC,0xBB,0xBA,0xBA,0xBA,0xBD,0x2D,0xBC,0x2F,0xFB,
  0x2F,0xB9,0xB4,0xB4,0xB8,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  0x2F,0xB9,0xB4,0xB3,0xB8,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,
  0x2F,0xBB,0xB4,0xB4,0xB7,0xB3,0xB2,0xB2,0xB2,0xB4,0xB4,0xB6,0xBA,0x2F,TRNP,TRNP,
  TRNP,0x2F,0xBA,0xBC,0xBA,0xBC,0xBA,0xB9,0xBA,0xBC,0xBC,0xB8,0xB8,0xBB,0x2F,TRNP,
  TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBC,0xB8,0xB9,0xBA,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xBB,0xB8,0xB9,0xBA,0x2F,0xFB,
  0x2F,0xB8,0xB2,0xB1,0xB1,0xB3,0xB2,0xB3,0xB6,0xB5,0xB6,0xB8,0xB8,0xBB,0x2F,0xFB,
  0x2F,0xBA,0xBA,0xB9,0xBA,0xBC,0xBA,0xBB,0xBA,0xB9,0xB9,0xBA,0xBC,0x2F,0xFB,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_74 [] =
{
  13,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB8,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB5,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xB6,0xB6,0xB1,0xB3,0xB6,0xB9,0xBB,0xBB,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0xB5,0xB2,0xB3,0xB7,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0x2F,0xB5,0xB3,0xB6,0xB6,0x2F,0xFB,0xFB,0xFB,0xFB,
  TRNP,TRNP,TRNP,0x2F,0xB5,0xB1,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB5,0xB1,0xB5,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB5,0xB2,0xB4,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB5,0xB3,0xB3,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB6,0xB3,0xB3,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB9,0xB8,0xB8,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP
};

static const unsigned char red_char_75 [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB7,0xB2,0xB2,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB8,0xB4,0xB2,0xB6,0x2F,0xFB,
  0x2F,0xBA,0xBB,0xBB,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBA,0xB9,0xB5,0xB6,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBB,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB9,0xB7,0xB7,0xB7,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBB,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB9,0xB8,0xB8,0xB8,0x2F,0xFB,
  0x2F,0xBC,0xBB,0xBA,0xBA,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBB,0xBA,0xBA,0xB9,0x2F,0xFB,
  0x2F,0xBC,0xBB,0xBA,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBB,0xBB,0xBA,0xB9,0x2F,0xFB,
  0x2F,0xBB,0xBB,0xBA,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xBB,0xBA,0xB9,0xBB,0x2F,0xFB,
  TRNP,0x2F,0xBB,0xBA,0xB6,0xB4,0x2F,0x2F,0x2F,0x2F,0xBA,0xB9,0xB8,0xB8,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xBD,0xB8,0xB8,0xB2,0xB1,0xB2,0xB4,0xB4,0xB8,0xB7,0xB6,0xBC,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0x2F,0xBC,0xBA,0xBA,0xBB,0xBD,0xBC,0xB9,0xBC,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_76 [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB7,0xB1,0xB1,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB6,0xB2,0xB1,0xB1,0x2F,0xFB,
  0x2F,0xB9,0xB4,0xB5,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,0x2F,0xB6,0xB4,0xB4,0xB8,0x2F,0xFB,
  TRNP,0x2F,0xB6,0xB5,0xB5,0xB9,0x2F,TRNP,TRNP,0x2F,0xB8,0xB3,0xB5,0xB5,0x2F,0xFB,0xFB,
  TRNP,0x2F,0xB8,0xB5,0xB4,0xB8,0x2F,0xFB,TRNP,0x2F,0xB6,0xB4,0xB5,0xB8,0x2F,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xB6,0xB6,0xB6,0xB9,0x2F,0x2F,0xB8,0xB5,0xB4,0xB3,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,0x2F,0xB8,0xB4,0xB6,0xB6,0xB9,0xB9,0xB3,0xB5,0xB2,0xB8,0x2F,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB4,0xB5,0xB5,0xB2,0xB2,0xB4,0xB4,0xB2,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB8,0xB4,0xB6,0xB4,0xB2,0xB5,0xB4,0xB8,0x2F,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB4,0xB6,0xB7,0xB4,0xB3,0xB2,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xBB,0xBB,0xBC,0xB8,0xB7,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_77 [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB6,0xB2,0xB5,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB8,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB7,0x2F,0xFB,TRNP,0x2F,0x2F,TRNP,TRNP,0x2F,0xBC,0xBD,0xBA,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB7,0x2F,0xFB,0x2F,0xB2,0xB2,0x2F,TRNP,0x2F,0xBB,0xBC,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB5,0xB7,0x2F,0x2F,0xB2,0xB7,0xB8,0xB2,0x2F,0x2F,0xBA,0xBB,0xB9,0x2F,0xFB,
  0x2F,0xB8,0xB7,0xB7,0x2F,0xB2,0xB8,0xB7,0xB7,0xB7,0xB4,0x2F,0xBA,0xB9,0xB9,0x2F,0xFB,
  0x2F,0xB7,0xB4,0xB6,0xB3,0xB4,0xB7,0xB7,0xB6,0xB8,0xBB,0xBB,0xB9,0xB8,0xB9,0x2F,0xFB,
  0x2F,0xB6,0xB3,0xB3,0xB2,0xB3,0xB8,0xBC,0xBB,0xB9,0xBB,0xBB,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xB6,0xB5,0xB4,0xB2,0xB3,0xBC,0x2F,0x2F,0xBB,0xBA,0xBA,0xB8,0xB9,0xB8,0x2F,0xFB,
  0x2F,0xBA,0xB5,0xB3,0xB2,0xB8,0x2F,0xFB,0xFB,0x2F,0xBA,0xB6,0xB8,0xB8,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBB,0xBA,0xBC,0x2F,0xFB,0xFB,TRNP,TRNP,0x2F,0xBD,0xBC,0xBD,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char red_char_78 [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB2,0xB1,0xB2,0xB2,0xB2,0x2F,TRNP,TRNP,0x2F,0xB2,0xB4,0xB4,0xB4,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xB8,0xB6,0xB6,0xB5,0xB1,0x2F,0x2F,0xB6,0xBB,0xBB,0xBA,0xBA,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0xB8,0xB3,0xB4,0xB3,0xB1,0xB1,0xB7,0xBB,0xBB,0xBB,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB8,0xB5,0xB3,0xB5,0xB8,0xBB,0xBB,0xBC,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB3,0xB5,0xB6,0xBC,0xBC,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB3,0xB3,0xB4,0xB7,0xBC,0xBB,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xB1,0xB2,0xB4,0xB3,0xB6,0xBB,0xBB,0xB6,0x2F,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x2F,0xB2,0xB3,0xB1,0xB4,0xBA,0xBA,0xBB,0xBB,0xBA,0xB4,0x2F,TRNP,TRNP,TRNP,
  TRNP,0x2F,0xB2,0xB3,0xB3,0xB1,0xB8,0x2F,0x2F,0xBA,0xB8,0xB8,0xB8,0xB2,0x2F,TRNP,TRNP,
  0x2F,0xB8,0xB8,0xB8,0xB7,0xB6,0x2F,0xFB,0xFB,0x2F,0xBA,0xBA,0xBA,0xB8,0xB5,0x2F,TRNP,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,0xFB,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_79 [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB4,0xB4,0xB1,0xB1,0x2F,TRNP,TRNP,TRNP,TRNP,0x2F,0xB2,0xB2,0xB1,0xB2,0x2F,0xFB,
  0x2F,0xBB,0xB9,0xB5,0xB2,0xB3,0x2F,TRNP,TRNP,0x2F,0xB2,0xB5,0xB4,0xB5,0xB9,0x2F,0xFB,
  TRNP,0x2F,0xBA,0xB7,0xB4,0xB3,0xB3,0x2F,0x2F,0xB3,0xB5,0xB6,0xB5,0xB9,0x2F,0xFB,0xFB,
  TRNP,TRNP,0x2F,0xBA,0xB6,0xB2,0xB5,0xB1,0xB1,0xB5,0xB4,0xB6,0xB9,0x2F,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0x2F,0xBA,0xB2,0xB7,0xB6,0xB6,0xB6,0xB6,0xB9,0x2F,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x2F,0xB8,0xB7,0xB6,0xB6,0xB5,0xB8,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xB9,0xB6,0xB6,0xB7,0x2F,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBA,0xB6,0xB5,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xB8,0xB5,0xB6,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0xBB,0xBA,0xB9,0xB9,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char red_char_7A [] =
{
  17,13,3,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB5,0xB1,0xB1,0xB1,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB1,0xB2,0xB2,0xB7,0x2F,0xFB,
  0x2F,0xB9,0xB8,0xB7,0xB8,0xB9,0xB8,0xB6,0xB1,0xB5,0xB5,0xB4,0xB4,0xB6,0xB8,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xB3,0xB5,0xB5,0xB4,0xB4,0xB4,0xB6,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0x2F,0x2F,0xB4,0xB2,0xB5,0xB5,0xB4,0xB3,0xBA,0x2F,0x2F,0xFB,
  TRNP,TRNP,TRNP,0x2F,0x2F,0xB4,0xB1,0xB4,0xB5,0xB6,0xB7,0xBA,0x2F,0x2F,0xFB,0xFB,0xFB,
  TRNP,0x2F,0x2F,0xB4,0xB2,0xB3,0xB2,0xB4,0xB3,0xBA,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,
  0x2F,0xB7,0xB1,0xB4,0xB4,0xB4,0xB2,0xBA,0x2F,0x2F,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x2F,0xB6,0xB3,0xB3,0xB5,0xB3,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,TRNP,
  0x2F,0xB6,0xB2,0xB2,0xB3,0xB5,0xB2,0xB1,0xB1,0xB1,0xB2,0xB1,0xB1,0xB1,0xB5,0x2F,0xFB,
  0x2F,0xB9,0xB9,0xB7,0xB8,0xB8,0xB8,0xB7,0xB6,0xB8,0xB9,0xB8,0xB7,0xB9,0xBC,0x2F,0xFB,
  0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char red_char_7F [] =
{
  6,6,3,
  0xBF,0xBF,0xBF,0xBF,TRNP,TRNP,
  0xBF,0xB1,0xB1,0xBF,0xFB,TRNP,
  0xBF,0xB5,0xB7,0xBF,0xFB,TRNP,
  TRNP,0xBF,0xB9,0xB9,0xBF,0xFB,
  TRNP,TRNP,0xBF,0xBF,0xBF,0xFB,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB
};


#define red_char_22 NULL
#define red_char_23 NULL
#define red_char_24 NULL
#define red_char_26 NULL
#define red_char_28 NULL
#define red_char_29 NULL
#define red_char_2A NULL
#define red_char_2B NULL
#define red_char_3B NULL
#define red_char_3C NULL
#define red_char_3D NULL
#define red_char_3E NULL
#define red_char_40 NULL
#define red_char_5B NULL
#define red_char_5C NULL
#define red_char_5D NULL
#define red_char_5E NULL
#define red_char_5F NULL
#define red_char_60 NULL
#define red_char_7B NULL
#define red_char_7C NULL
#define red_char_7D NULL
#define red_char_7E NULL

/* ---------------------------------------------------------------------------- */

static const unsigned char wilv_char_21 [] =
{
  7,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x63,0x50,0x51,0x63,0x6A,0xFB,
  0x6A,0x5A,0x53,0x53,0x5A,0x6A,0xFB,
  0x6A,0x5A,0x55,0x51,0x5A,0x6A,0xFB,
  0x6A,0x5A,0x55,0x53,0x5A,0x6A,0xFB,
  0x6A,0x5A,0x55,0x55,0x5A,0x6A,0xFB,
  0x6A,0x63,0x5C,0x5F,0x63,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x61,0x5B,0x57,0x61,0x6A,0xFB,
  0x6A,0x62,0x61,0x5F,0x62,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_27 [] =
{
  6,6,0,
  TRNP,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,0x6A,0x51,0x51,0x6A,0xFB,
  TRNP,0x6A,0x57,0x5B,0x6A,0xFB,
  0x6A,0x5F,0x5F,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_2D [] =
{
  9,5,4,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x68,0x5C,0x51,0x50,0x51,0x51,0x57,0x6A,0xFB,
  0x6A,0x62,0x62,0x59,0x5F,0x62,0x62,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_2E [] =
{
  6,5,8,
  0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x59,0x55,0x51,0x6A,0xFB,
  0x6A,0x62,0x61,0x5F,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_2F [] =
{
  10,13,0,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x61,0x51,0x57,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x5B,0x51,0x5B,0x6A,0xFB,
  TRNP,TRNP,TRNP,0x6A,0x61,0x51,0x57,0x6A,0xFB,0xFB,
  TRNP,TRNP,TRNP,0x6A,0x5B,0x51,0x61,0x6A,0xFB,TRNP,
  TRNP,TRNP,0x6A,0x61,0x51,0x57,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,0x6A,0x57,0x51,0x61,0x6A,0xFB,TRNP,TRNP,
  TRNP,0x6A,0x61,0x51,0x57,0x6A,0xFB,0xFB,TRNP,TRNP,
  TRNP,0x6A,0x57,0x51,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x61,0x51,0x57,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x57,0x51,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_30 [] =
{
  12,13,0,
  TRNP,TRNP,0x69,0x69,0x69,0x69,0x69,0x69,0x69,TRNP,TRNP,TRNP,
  TRNP,0x69,0x52,0x50,0xA8,0xA8,0xA8,0x56,0x57,0x69,TRNP,TRNP,
  0x69,0x5B,0x54,0x56,0x5F,0x5F,0x61,0x5B,0x57,0x5F,0x69,TRNP,
  0x69,0x5B,0x56,0x5B,0x69,0x69,0x69,0x5B,0x57,0x5B,0x69,0xFB,
  0x69,0x5B,0x56,0x5B,0x69,0xFB,0x69,0x5B,0x56,0x5D,0x69,0xFB,
  0x69,0x5B,0x54,0x5B,0x69,0xFB,0x69,0x5F,0x57,0x5D,0x69,0xFB,
  0x69,0x5B,0x54,0x5D,0x69,0xFB,0x69,0x5D,0x56,0x5D,0x69,0xFB,
  0x69,0x5B,0x54,0x5D,0x69,0xFB,0x69,0x63,0x5B,0x5D,0x69,0xFB,
  0x69,0x5B,0x56,0x59,0x69,0x69,0x69,0x5F,0x5F,0x5F,0x69,0xFB,
  0x69,0x5F,0x56,0x52,0x52,0x54,0x57,0x5F,0x5F,0x65,0x69,0xFB,
  TRNP,0x69,0x65,0x63,0x5F,0x5F,0x5F,0x63,0x65,0x69,0xFB,0xFB,
  TRNP,TRNP,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_31 [] =
{
  8,13,0,
  TRNP,TRNP,TRNP,0x69,0x69,0x69,0x69,TRNP,
  TRNP,TRNP,0x69,0xA8,0x50,0x50,0x69,0xFB,
  TRNP,0x69,0xA8,0x5B,0x55,0x55,0x69,0xFB,
  0x69,0x52,0x5B,0x58,0x55,0x55,0x69,0xFB,
  0x69,0x69,0x69,0x58,0x55,0x55,0x69,0xFB,
  TRNP,0xFB,0x69,0x58,0x55,0x57,0x69,0xFB,
  TRNP,TRNP,0x69,0x52,0x52,0x55,0x69,0xFB,
  TRNP,TRNP,0x69,0x52,0x52,0x55,0x69,0xFB,
  TRNP,TRNP,0x69,0x55,0x52,0x57,0x69,0xFB,
  TRNP,TRNP,0x69,0x55,0x52,0x52,0x69,0xFB,
  TRNP,TRNP,0x69,0x5F,0x5C,0x61,0x69,0xFB,
  TRNP,TRNP,0x69,0x69,0x69,0x69,0x69,0xFB,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_32 [] =
{
  12,13,0,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,TRNP,TRNP,TRNP,
  0x69,0x57,0x52,0xA8,0xA8,0xA8,0x51,0x57,0x57,0x69,TRNP,TRNP,
  0x69,0x5F,0x61,0x5F,0x5F,0x5F,0x5C,0x57,0x58,0x58,0x69,TRNP,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x58,0x58,0x57,0x69,0xFB,
  TRNP,0x69,0x69,0x69,0x69,0x69,0x69,0x5B,0x5B,0x55,0x69,0xFB,
  TRNP,0x69,0x52,0x55,0x50,0x50,0x52,0x58,0x58,0x57,0x69,0xFB,
  0x69,0x52,0x58,0x58,0x5C,0x5F,0x5C,0x5F,0x61,0x69,0xFB,0xFB,
  0x69,0x55,0x5C,0x5C,0x69,0x69,0x69,0x69,0x69,0xFB,0xFB,TRNP,
  0x69,0x57,0x5C,0x58,0x69,0x69,0x69,0x69,0x69,0x69,0x69,TRNP,
  0x69,0x51,0x58,0x58,0x51,0xA8,0xA8,0xA8,0xA8,0x51,0x69,0xFB,
  0x69,0x5C,0x5F,0x62,0x61,0x5B,0x5C,0x5F,0x61,0x61,0x69,0xFB,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_33 [] =
{
  12,13,0,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,TRNP,TRNP,TRNP,
  0x69,0x57,0x51,0x51,0xA8,0xA8,0x50,0x52,0x55,0x69,TRNP,TRNP,
  0x69,0x58,0x5C,0x5F,0x5C,0x5C,0x5C,0x5C,0x5C,0x5B,0x69,TRNP,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x63,0x5F,0x5C,0x69,0xFB,
  TRNP,0xFB,0xFB,0xFB,0x69,0x69,0x69,0x66,0x61,0x5F,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,0x69,0xA8,0x52,0x5C,0x61,0x5F,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,0x69,0x5C,0x62,0x61,0x61,0x5F,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,0x69,0x69,0x69,0x66,0x63,0x61,0x69,0xFB,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x63,0x63,0x61,0x69,0xFB,
  0x69,0x55,0x57,0x55,0x57,0x57,0x57,0x62,0x62,0x61,0x69,0xFB,
  0x69,0x62,0x62,0x61,0x62,0x62,0x66,0x66,0x66,0x69,0xFB,0xFB,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_34 [] =
{
  12,13,0,
  0x69,0x69,0x69,0x69,0x69,TRNP,0x69,0x69,0x69,0x69,0x69,TRNP,
  0x69,0x52,0x52,0x58,0x69,0xFB,0x69,0x51,0x52,0x58,0x69,0xFB,
  0x69,0x52,0x58,0x5F,0x69,0xFB,0x69,0x51,0x57,0x5C,0x69,0xFB,
  0x69,0x57,0x5C,0x58,0x69,0xFB,0x69,0x51,0x57,0x5F,0x69,0xFB,
  0x69,0x58,0x57,0x55,0x69,0x69,0x69,0x51,0x5B,0x61,0x69,0xFB,
  0x69,0x55,0x55,0x51,0xA8,0xA8,0xA8,0xA8,0x5C,0x61,0x69,0xFB,
  0x69,0x5C,0x5F,0x5B,0x5C,0x5F,0x5C,0xA8,0x5C,0x61,0x69,0xFB,
  0x69,0x69,0x69,0x69,0x69,0x69,0x69,0xA8,0x58,0x61,0x69,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0x69,0xA8,0x58,0x5F,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x69,0x51,0x57,0x5F,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x69,0x5B,0x5F,0x66,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x69,0x69,0x69,0x69,0x69,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_35 [] =
{
  12,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x56,0x52,0xA8,0xA8,0xA8,0xA8,0x52,0x54,0x57,0x6A,0xFB,
  0x6A,0x57,0x56,0x56,0x56,0x59,0x5D,0x59,0x5D,0x5D,0x6A,0xFB,
  0x6A,0x59,0x54,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x59,0x56,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,
  0x6A,0x59,0x56,0x54,0x52,0xA8,0x52,0x56,0x57,0x6A,TRNP,TRNP,
  0x6A,0x5D,0x5D,0x5F,0x5F,0x5F,0x5F,0x56,0x57,0x59,0x6A,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x59,0x5D,0x61,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5B,0x61,0x61,0x6A,0xFB,
  0x6A,0x56,0xA8,0xA8,0xA8,0xA8,0x56,0x5B,0x61,0x61,0x6A,0xFB,
  0x6A,0x5D,0x5D,0x5D,0x5D,0x5F,0x5F,0x61,0x65,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_36 [] =
{
  12,13,0,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,0x6A,0x5D,0x54,0xA8,0xA8,0x52,0x52,0x54,0x57,0x6A,0xFB,
  0x6A,0x5B,0x57,0x61,0x5F,0x5D,0x5B,0x5D,0x5F,0x61,0x6A,0xFB,
  0x6A,0x59,0x57,0x61,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x56,0x56,0x61,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,
  0x6A,0x54,0x57,0x56,0x54,0x54,0x56,0x57,0x5D,0x6A,TRNP,TRNP,
  0x6A,0x54,0x57,0x57,0x5D,0x5F,0x5F,0x57,0x57,0x5D,0x6A,TRNP,
  0x6A,0x54,0x59,0x57,0x6A,0x6A,0x6A,0x59,0x54,0x56,0x6A,0xFB,
  0x6A,0x57,0x5D,0x5B,0x6A,0x6A,0x6A,0x5B,0x56,0x57,0x6A,0xFB,
  0x6A,0x5B,0x57,0x54,0xA8,0xA8,0xA8,0x54,0x56,0x5D,0x6A,0xFB,
  TRNP,0x6A,0x5B,0x5D,0x5D,0x5F,0x5D,0x5B,0x5D,0x6A,0xFB,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_37 [] =
{
  12,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x59,0x56,0x52,0xA8,0xA8,0xA8,0x52,0x57,0x6A,TRNP,TRNP,
  0x6A,0x63,0x61,0x5F,0x61,0x5F,0x61,0x5B,0x57,0x5B,0x6A,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5B,0x57,0x5B,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0x6A,0x5B,0x56,0x5D,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x57,0x5F,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x5D,0x56,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x63,0x5B,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x63,0x63,0x65,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x63,0x65,0x65,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x61,0x63,0x63,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_38 [] =
{
  12,13,0,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  TRNP,0x6A,0x59,0x57,0x56,0x52,0x52,0x56,0x56,0x6A,TRNP,TRNP,
  0x6A,0x5D,0x5D,0x5B,0x63,0x65,0x65,0x5B,0x57,0x5B,0x6A,TRNP,
  0x6A,0x5F,0x5B,0x65,0x6A,0x6A,0x6A,0x65,0x56,0x5D,0x6A,0xFB,
  0x6A,0x61,0x5B,0x5F,0x6A,0x6A,0x6A,0x5F,0x56,0x63,0x6A,0xFB,
  TRNP,0x6A,0x59,0x59,0x52,0x54,0x54,0x56,0x56,0x6A,0xFB,0xFB,
  TRNP,0x6A,0x59,0x5F,0x5F,0x63,0x63,0x5D,0x54,0x6A,0xFB,TRNP,
  0x6A,0x5D,0x5D,0x63,0x6A,0x6A,0x6A,0x5F,0x54,0x5F,0x6A,TRNP,
  0x6A,0x57,0x54,0x5F,0x6A,0x6A,0x6A,0x59,0x54,0x57,0x6A,0xFB,
  0x6A,0x5F,0x57,0x54,0x50,0xA8,0x50,0x56,0x57,0x5F,0x6A,0xFB,
  TRNP,0x6A,0x5B,0x5F,0x61,0x5F,0x5F,0x5F,0x5D,0x6A,0xFB,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_39 [] =
{
  12,13,0,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  TRNP,0x6A,0x61,0x57,0x54,0x52,0x52,0x54,0x57,0x6A,TRNP,TRNP,
  0x6A,0x67,0x67,0x65,0x67,0x67,0x67,0x61,0x63,0x59,0x6A,TRNP,
  0x6A,0x65,0x65,0x63,0x6A,0x6A,0x6A,0x61,0x63,0x57,0x6A,0xFB,
  0x6A,0x61,0x5F,0x5F,0x6A,0x6A,0x6A,0x5D,0x63,0x57,0x6A,0xFB,
  0x6A,0x5D,0x5B,0x5F,0x54,0xA8,0x54,0x5D,0x63,0x59,0x6A,0xFB,
  TRNP,0x6A,0x61,0x63,0x63,0x5F,0x5D,0x59,0x63,0x5B,0x6A,0xFB,
  TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5B,0x5F,0x5D,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x59,0x63,0x5F,0x6A,0xFB,
  0x6A,0x57,0x56,0x54,0x54,0x54,0xA8,0x57,0x67,0x67,0x6A,0xFB,
  0x6A,0x61,0x61,0x61,0x63,0x63,0x5F,0x5F,0x67,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_61 [] =
{
  16,13,0,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x5B,0x59,0x51,0x51,0x53,0x61,0x6A,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x5C,0x5F,0x5C,0x61,0x62,0x57,0x5B,0x64,0x6A,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x61,0x5C,0x59,0x61,0x6A,0x6A,0x5F,0x59,0x5B,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,0x6A,0x5C,0x59,0x5B,0x6A,0x6A,0x6A,0x5F,0x59,0x5C,0x5F,0x6A,0xFB,
  TRNP,TRNP,0x6A,0x61,0x57,0x57,0x61,0x6A,0x55,0x55,0x5B,0x59,0x5B,0x61,0x6A,0xFB,
  TRNP,TRNP,0x6A,0x5C,0x57,0x59,0x6A,0x6A,0x5F,0x62,0x5F,0x59,0x5C,0x61,0x6A,0xFB,
  TRNP,0x6A,0x61,0x57,0x55,0x61,0x6A,0x6A,0x6A,0x6A,0x5F,0x5B,0x5B,0x5F,0x6A,0xFB,
  TRNP,0x6A,0x5B,0x51,0x53,0x6A,0xFB,0xFB,0xFB,0x6A,0x61,0x5B,0x59,0x61,0x6A,0xFB,
  0x6A,0x5C,0x57,0x51,0x61,0x6A,0xFB,TRNP,TRNP,0x6A,0x61,0x5B,0x57,0x61,0x6A,0xFB,
  0x6A,0x5C,0x5C,0x5B,0x6A,0xFB,0xFB,TRNP,TRNP,0x6A,0x62,0x61,0x5F,0x62,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_62 [] =
{
  16,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x59,0x53,0x51,0x53,0x55,0x50,0x50,0x51,0x51,0x50,0x57,0x5F,0x6A,TRNP,TRNP,
  0x6A,0x5F,0x5F,0x5F,0x61,0x64,0x5F,0x5F,0x5F,0x5F,0x53,0x53,0x55,0x5F,0x6A,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x61,0x53,0x57,0x53,0x5F,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x61,0x5B,0x53,0x50,0x62,0x6A,0xFB,
  0x6A,0x5B,0x51,0x51,0x51,0x51,0x50,0x51,0x51,0x51,0x57,0x53,0x62,0x6A,0xFB,0xFB,
  0x6A,0x5B,0x5B,0x55,0x59,0x5C,0x5C,0x5F,0x5C,0x5C,0x57,0x50,0x62,0x6A,0xFB,TRNP,
  0x6A,0x5B,0x5C,0x53,0x5B,0x6A,0x6A,0x6A,0x6A,0x61,0x53,0x53,0x50,0x5B,0x6A,TRNP,
  0x6A,0x5B,0x5C,0x55,0x59,0x6A,0x6A,0x6A,0x6A,0x61,0x51,0x57,0x59,0x5B,0x6A,0xFB,
  0x6A,0x5C,0x5B,0x57,0x59,0x50,0x51,0x50,0x50,0x51,0x55,0x57,0x59,0x62,0x6A,0xFB,
  0x6A,0x62,0x61,0x5F,0x61,0x5B,0x5C,0x59,0x59,0x5C,0x5B,0x5B,0x5F,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_63 [] =
{
  15,13,0,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x62,0x5C,0x5C,0x59,0x51,0x51,0x51,0x51,0x59,0x6A,0xFB,
  TRNP,0x6A,0x62,0x59,0x64,0x64,0x64,0x64,0x5C,0x61,0x5C,0x5F,0x61,0x6A,0xFB,
  TRNP,0x6A,0x5C,0x5F,0x64,0x66,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x62,0x5C,0x5F,0x64,0x6A,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x6A,0x5F,0x5C,0x61,0x64,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x5C,0x61,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x62,0x5C,0x62,0x64,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0x6A,0x5C,0x62,0x64,0x5C,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,0x6A,0x64,0x62,0x64,0x62,0x55,0x51,0x55,0x51,0x53,0x51,0x59,0x6A,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x67,0x62,0x62,0x5C,0x62,0x61,0x61,0x61,0x5F,0x6A,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_64 [] =
{
  16,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x68,0x5C,0x51,0x51,0x51,0x51,0x50,0x50,0x51,0x55,0x61,0x6A,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x62,0x61,0x5F,0x5F,0x5F,0x5C,0x5C,0x5F,0x59,0x59,0x57,0x62,0x6A,TRNP,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5F,0x57,0x55,0x59,0x6A,0xFB,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,0x6A,0x57,0x51,0x59,0x62,0x6A,TRNP,
  0x6A,0x5C,0x57,0x57,0x5C,0x6A,0xFB,TRNP,TRNP,0x6A,0x57,0x51,0x55,0x5F,0x6A,0xFB,
  0x6A,0x5F,0x5B,0x5C,0x5F,0x6A,0xFB,TRNP,TRNP,0x6A,0x57,0x51,0x53,0x5F,0x6A,0xFB,
  0x6A,0x5C,0x5B,0x5B,0x5F,0x6A,0xFB,TRNP,TRNP,0x6A,0x55,0x51,0x53,0x62,0x6A,0xFB,
  0x6A,0x5C,0x59,0x59,0x5C,0x6A,0x6A,0x6A,0x6A,0x55,0x55,0x51,0x5B,0x6A,0xFB,0xFB,
  0x6A,0x5C,0x5B,0x57,0x55,0x51,0x50,0x50,0x55,0x57,0x53,0x5B,0x62,0x6A,0xFB,TRNP,
  0x6A,0x61,0x5F,0x5F,0x5C,0x5C,0x5C,0x5C,0x5F,0x5F,0x61,0x6A,0x6A,0xFB,0xFB,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_65 [] =
{
  15,13,0,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x5F,0x55,0x59,0x53,0x53,0x55,0x55,0x53,0x5C,0x6A,0xFB,
  TRNP,0x6A,0x64,0x5B,0x59,0x59,0x61,0x62,0x61,0x64,0x64,0x5F,0x62,0x6A,0xFB,
  TRNP,0x6A,0x5F,0x57,0x57,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x61,0x59,0x57,0x57,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x5F,0x59,0x57,0x57,0x57,0x57,0x55,0x55,0x55,0x51,0x51,0x5F,0x6A,0xFB,
  0x6A,0x5F,0x59,0x59,0x57,0x59,0x61,0x64,0x62,0x64,0x61,0x5F,0x62,0x6A,0xFB,
  0x6A,0x61,0x57,0x57,0x55,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0x6A,0x5B,0x51,0x53,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0x6A,0x64,0x5F,0x53,0x57,0x53,0x51,0x51,0x51,0x53,0x55,0x5B,0x6A,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x61,0x5C,0x5F,0x5F,0x61,0x5F,0x61,0x61,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_66 [] =
{
  13,13,0,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x61,0x55,0x50,0x50,0x50,0x51,0x5B,0x6A,0xFB,
  TRNP,0x6A,0x64,0x61,0x59,0x5F,0x5F,0x5F,0x5C,0x5C,0x61,0x6A,0xFB,
  TRNP,0x6A,0x5C,0x61,0x57,0x61,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x62,0x5C,0x5C,0x57,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,0xFB,
  0x6A,0x5F,0x5B,0x57,0x55,0x50,0x50,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x59,0x55,0x55,0x5F,0x5C,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x5C,0x5B,0x57,0x5F,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x59,0x53,0x5C,0x6A,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x59,0x51,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x61,0x61,0x5B,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_67 [] =
{
  17,13,0,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x62,0x5C,0x5C,0x57,0x55,0x51,0x51,0x51,0x51,0x55,0x5F,0x6A,0xFB,
  TRNP,0x6A,0x64,0x5C,0x5F,0x64,0x66,0x64,0x64,0x5C,0x61,0x5C,0x5F,0x5F,0x62,0x6A,0xFB,
  TRNP,0x6A,0x59,0x5C,0x5F,0x64,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x62,0x5B,0x5C,0x5F,0x6A,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,
  0x6A,0x61,0x5C,0x5C,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x61,0x5C,0x5C,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x59,0x50,0x50,0x5C,0x6A,0xFB,
  0x6A,0x61,0x57,0x5C,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x5C,0x51,0x50,0x5F,0x6A,0xFB,
  TRNP,0x6A,0x53,0x5C,0x62,0x64,0x6A,0x6A,0x6A,0x6A,0x6A,0x5F,0x51,0x50,0x5F,0x6A,0xFB,
  TRNP,0x6A,0x64,0x5B,0x62,0x64,0x5B,0x51,0x50,0x51,0x53,0x5C,0x51,0x50,0x5F,0x6A,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x66,0x67,0x62,0x62,0x5C,0x62,0x61,0x61,0x5B,0x5B,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_68 [] =
{
  16,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x5C,0x55,0x55,0x5B,0x6A,0xFB,TRNP,TRNP,0x6A,0x5B,0x51,0x51,0x5B,0x6A,0xFB,
  0x6A,0x61,0x5F,0x5C,0x5C,0x6A,0xFB,TRNP,TRNP,0x6A,0x5C,0x59,0x57,0x61,0x6A,0xFB,
  0x6A,0x61,0x5C,0x5C,0x5F,0x6A,0xFB,TRNP,TRNP,0x6A,0x5C,0x57,0x55,0x5F,0x6A,0xFB,
  0x6A,0x61,0x5C,0x5C,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,0x5C,0x57,0x51,0x5F,0x6A,0xFB,
  0x6A,0x61,0x5C,0x5C,0x5C,0x59,0x55,0x51,0x51,0x53,0x59,0x57,0x51,0x5B,0x6A,0xFB,
  0x6A,0x61,0x5B,0x5B,0x61,0x61,0x61,0x5F,0x5F,0x5F,0x5F,0x57,0x51,0x5B,0x6A,0xFB,
  0x6A,0x5F,0x59,0x5B,0x61,0x6A,0x6A,0x6A,0x6A,0x6A,0x5F,0x55,0x51,0x5B,0x6A,0xFB,
  0x6A,0x5F,0x57,0x59,0x61,0x6A,0xFB,0xFB,0xFB,0x6A,0x5F,0x55,0x51,0x5B,0x6A,0xFB,
  0x6A,0x5F,0x59,0x5B,0x5F,0x6A,0xFB,TRNP,TRNP,0x6A,0x5C,0x53,0x53,0x5B,0x6A,0xFB,
  0x6A,0x61,0x5F,0x5F,0x62,0x6A,0xFB,TRNP,TRNP,0x6A,0x61,0x5C,0x5B,0x61,0x6A,0xFB,
  0x6A,0x68,0x6A,0x6A,0x68,0x6A,0xFB,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_69 [] =
{
  7,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x5B,0x53,0x53,0x5C,0x6A,0xFB,
  0x6A,0x5F,0x5F,0x5C,0x62,0x6A,0xFB,
  0x6A,0x5C,0x61,0x5C,0x61,0x6A,0xFB,
  0x6A,0x5F,0x61,0x61,0x61,0x6A,0xFB,
  0x6A,0x5F,0x61,0x5F,0x61,0x6A,0xFB,
  0x6A,0x5F,0x62,0x5F,0x62,0x6A,0xFB,
  0x6A,0x5C,0x5F,0x62,0x62,0x6A,0xFB,
  0x6A,0x5C,0x5B,0x5F,0x61,0x6A,0xFB,
  0x6A,0x5C,0x57,0x5C,0x5F,0x6A,0xFB,
  0x6A,0x61,0x5F,0x61,0x61,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_6A [] =
{
  12,13,0,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x5B,0x51,0x55,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x59,0x5F,0x64,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x61,0x61,0x62,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x61,0x62,0x62,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x61,0x5F,0x5C,0x62,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x5C,0x5C,0x61,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x5F,0x59,0x5F,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x5F,0x62,0x5C,0x59,0x5F,0x6A,0xFB,
  0x6A,0x59,0x53,0x55,0x53,0x51,0x5F,0x5F,0x5C,0x6A,0x6A,0xFB,
  0x6A,0x5F,0x5C,0x5F,0x5F,0x5B,0x62,0x62,0x6A,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_6B [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,
  0x6A,0x59,0x51,0x50,0x57,0x6A,0xFB,TRNP,0x6A,0x50,0x50,0x50,0x50,0x5C,0x6A,0xFB,TRNP,
  0x6A,0x5B,0x59,0x53,0x55,0x6A,0xFB,0x6A,0x50,0x55,0x59,0x57,0x61,0x6A,0xFB,0xFB,TRNP,
  0x6A,0x59,0x53,0x55,0x59,0x6A,0x6A,0x51,0x55,0x55,0x55,0x5C,0x6A,0xFB,0xFB,TRNP,TRNP,
  0x6A,0x5B,0x51,0x50,0x5B,0x6A,0x51,0x57,0x55,0x53,0x5F,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x53,0x51,0x55,0x57,0x59,0x5B,0x55,0x55,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5C,0x53,0x51,0x5B,0x6A,0x5F,0x55,0x53,0x53,0x51,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5B,0x55,0x51,0x5B,0x6A,0x6A,0x5C,0x53,0x51,0x53,0x57,0x6A,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5C,0x57,0x51,0x59,0x6A,0xFB,0x6A,0x5C,0x51,0x53,0x5C,0x55,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x59,0x57,0x53,0x59,0x6A,0xFB,TRNP,0x6A,0x5B,0x55,0x5C,0x5B,0x57,0x6A,TRNP,TRNP,
  0x6A,0x5F,0x5C,0x5C,0x5F,0x6A,0xFB,TRNP,TRNP,0x6A,0x62,0x64,0x61,0x62,0x59,0x6A,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_6C [] =
{
  12,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x61,0x55,0x51,0x5B,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x64,0x5F,0x59,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x62,0x61,0x61,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x62,0x62,0x61,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x62,0x5C,0x5F,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x61,0x5C,0x5C,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x59,0x5F,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x59,0x5C,0x62,0x5F,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,0x6A,0x5C,0x5F,0x5F,0x51,0x53,0x55,0x53,0x59,0x6A,0xFB,
  TRNP,0x6A,0x6A,0x62,0x62,0x5B,0x5F,0x5F,0x5C,0x5F,0x6A,0xFB,
  TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_6D [] =
{
  17,13,0,
  TRNP,TRNP,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  TRNP,0x6A,0x57,0x50,0x59,0x6A,TRNP,TRNP,TRNP,TRNP,0x6A,0x55,0x50,0x53,0x6A,TRNP,TRNP,
  0x6A,0x5C,0x51,0x50,0x57,0x59,0x6A,TRNP,TRNP,0x6A,0x57,0x5C,0x55,0x59,0x5C,0x6A,TRNP,
  0x6A,0x5B,0x53,0x53,0x59,0x62,0x5B,0x6A,0x6A,0x53,0x5F,0x5B,0x59,0x5C,0x62,0x6A,0xFB,
  0x6A,0x5C,0x53,0x57,0x5C,0x62,0x62,0x55,0x55,0x57,0x5B,0x57,0x5B,0x5C,0x62,0x6A,0xFB,
  0x6A,0x59,0x53,0x57,0x59,0x64,0x62,0x61,0x5F,0x57,0x59,0x55,0x5C,0x61,0x64,0x6A,0xFB,
  0x6A,0x59,0x53,0x55,0x5B,0x64,0x62,0x61,0x5C,0x59,0x57,0x53,0x61,0x61,0x65,0x6A,0xFB,
  0x6A,0x59,0x55,0x53,0x5C,0x6A,0x64,0x61,0x59,0x5F,0x6A,0x5B,0x61,0x62,0x62,0x6A,0xFB,
  0x6A,0x57,0x55,0x55,0x5B,0x6A,0x6A,0x61,0x5F,0x6A,0x6A,0x5C,0x61,0x61,0x62,0x6A,0xFB,
  0x6A,0x57,0x53,0x53,0x5B,0x6A,0xFB,0x6A,0x6A,0xFB,0x6A,0x5C,0x62,0x5F,0x5F,0x6A,0xFB,
  0x6A,0x5C,0x5C,0x5C,0x5F,0x6A,0xFB,TRNP,0xFB,0xFB,0x6A,0x61,0x64,0x62,0x61,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_6E [] =
{
  17,13,0,
  TRNP,TRNP,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,0x6A,0x50,0x50,0x61,0x6A,TRNP,TRNP,TRNP,TRNP,0x6A,0x5C,0xA8,0x50,0x5C,0x68,0xFB,
  0x6A,0x5C,0x55,0x57,0x55,0x61,0x6A,TRNP,TRNP,TRNP,0x6A,0x59,0xA8,0x55,0x5C,0x6A,0xFB,
  0x6A,0x5F,0x59,0x57,0x57,0x59,0x61,0x6A,TRNP,TRNP,0x6A,0x59,0xA8,0x57,0x5F,0x6A,0xFB,
  0x6A,0x5F,0x57,0x57,0x55,0x59,0x59,0x61,0x6A,TRNP,0x6A,0x5B,0xA8,0x55,0x5F,0x6A,0xFB,
  0x6A,0x61,0x59,0x59,0x59,0x59,0x59,0x59,0x61,0x6A,0x6A,0x5B,0xA8,0x53,0x5F,0x6A,0xFB,
  0x6A,0x61,0x59,0x57,0x55,0x59,0x59,0x55,0x51,0x61,0x6A,0x59,0xA8,0x53,0x5F,0x6A,0xFB,
  0x6A,0x61,0x59,0x55,0x5B,0x6A,0x61,0x51,0x51,0x55,0x55,0x51,0xA8,0x53,0x5F,0x6A,0xFB,
  0x6A,0x61,0x57,0x53,0x5C,0x6A,0x6A,0x61,0x51,0x57,0x55,0x51,0xA8,0x53,0x5F,0x6A,0xFB,
  0x6A,0x62,0x57,0x53,0x5C,0x6A,0xFB,0x6A,0x61,0x53,0x51,0x51,0xA8,0x51,0x62,0x6A,0xFB,
  0x6A,0x62,0x5F,0x5C,0x61,0x6A,0xFB,TRNP,0x6A,0x6A,0x61,0x5C,0x59,0x5C,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_6F [] =
{
  18,13,0,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x5F,0x53,0x50,0x50,0x50,0x50,0x50,0x55,0x5F,0x6A,0x6A,TRNP,TRNP,TRNP,
  TRNP,0x6A,0x62,0x50,0x57,0x57,0x5C,0x5C,0x62,0x62,0x61,0x59,0x5B,0x5C,0x62,0x6A,TRNP,TRNP,
  TRNP,0x6A,0x51,0x53,0x57,0x62,0x6A,0x6A,0x6A,0x6A,0x6A,0x64,0x5B,0x5C,0x57,0x6A,0xFB,TRNP,
  0x6A,0x61,0x55,0x57,0x5C,0x6A,0xFB,0xFB,0xFB,0xFB,0xFB,0x6A,0x5F,0x5C,0x59,0x61,0x6A,TRNP,
  0x6A,0x5C,0x55,0x57,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x61,0x5F,0x61,0x6A,0xFB,
  0x6A,0x5C,0x55,0x55,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x62,0x62,0x61,0x6A,0xFB,
  0x6A,0x5C,0x55,0x53,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,0x6A,0x61,0x62,0x62,0x61,0x6A,0xFB,
  TRNP,0x6A,0x51,0x51,0x53,0x57,0x6A,0x6A,0x6A,0x6A,0x6A,0x59,0x5F,0x61,0x61,0x6A,0xFB,0xFB,
  TRNP,0x6A,0x62,0x5B,0x51,0x57,0x50,0x50,0x50,0x53,0x55,0x5C,0x61,0x5C,0x64,0x6A,0xFB,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x5F,0x5F,0x5C,0x5B,0x5F,0x64,0x61,0x62,0x62,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_70 [] =
{
  16,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x5C,0x50,0x51,0x50,0x50,0x50,0x50,0x50,0x51,0x51,0x51,0x61,0x6A,TRNP,TRNP,
  0x6A,0x61,0x5C,0x5F,0x5C,0x5F,0x5F,0x5F,0x5C,0x5B,0x5B,0x55,0x51,0x61,0x6A,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5C,0x57,0x53,0x59,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5C,0x55,0x57,0x5C,0x6A,0xFB,
  0x6A,0x5B,0x51,0x50,0x50,0x50,0x50,0x50,0x53,0x51,0x53,0x53,0x57,0x53,0x6A,0xFB,
  0x6A,0x5C,0x55,0x59,0x59,0x5C,0x61,0x61,0x5F,0x5B,0x53,0x53,0x53,0x6A,0xFB,0xFB,
  0x6A,0x5B,0x55,0x57,0x57,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  0x6A,0x59,0x57,0x55,0x59,0x6A,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,
  0x6A,0x59,0x57,0x55,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x5F,0x61,0x61,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_71 [] =
{
  18,13,0,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x5F,0x53,0x50,0x50,0x50,0x50,0x50,0x55,0x5F,0x6A,0x6A,TRNP,TRNP,TRNP,
  TRNP,0x6A,0x62,0x50,0x57,0x57,0x5C,0x5C,0x62,0x62,0x61,0x59,0x5B,0x5C,0x62,0x6A,TRNP,TRNP,
  TRNP,0x6A,0x51,0x53,0x57,0x62,0x6A,0x6A,0x6A,0x6A,0x6A,0x64,0x5B,0x5C,0x57,0x6A,0xFB,TRNP,
  0x6A,0x61,0x55,0x57,0x5C,0x6A,0xFB,0xFB,0xFB,0xFB,0xFB,0x6A,0x5F,0x5C,0x59,0x61,0x6A,TRNP,
  0x6A,0x5C,0x55,0x57,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x61,0x5F,0x61,0x6A,0xFB,
  0x6A,0x5C,0x55,0x55,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x6A,0x5F,0x62,0x62,0x61,0x6A,0xFB,
  0x6A,0x5C,0x55,0x53,0x59,0x6A,0xFB,TRNP,TRNP,0x6A,0x62,0x62,0x61,0x62,0x62,0x61,0x6A,0xFB,
  TRNP,0x6A,0x51,0x51,0x53,0x57,0x6A,0x6A,0x6A,0x6A,0x5C,0x59,0x5F,0x61,0x61,0x6A,0xFB,0xFB,
  TRNP,0x6A,0x62,0x5B,0x51,0x57,0x50,0x50,0x50,0x53,0x55,0x5C,0x61,0x5C,0x64,0x61,0x6A,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x5F,0x5F,0x5C,0x5B,0x5F,0x64,0x61,0x62,0x62,0x61,0x62,0x5C,0x6A,0xFB,
  TRNP,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_72 [] =
{
  16,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x5C,0x50,0x51,0x50,0x50,0x50,0x50,0x50,0x51,0x51,0x51,0x61,0x6A,TRNP,TRNP,
  0x6A,0x61,0x5C,0x5F,0x5C,0x5F,0x5F,0x5F,0x5C,0x5B,0x5B,0x55,0x51,0x61,0x6A,TRNP,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5C,0x57,0x53,0x59,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x5C,0x55,0x57,0x5C,0x6A,0xFB,
  0x6A,0x5B,0x51,0x50,0x50,0x50,0x50,0x50,0x53,0x51,0x53,0x53,0x57,0x6A,0x6A,0xFB,
  0x6A,0x5C,0x55,0x59,0x59,0x5C,0x61,0x61,0x5F,0x5B,0x53,0x53,0x55,0x6A,0x6A,0xFB,
  0x6A,0x5B,0x55,0x57,0x57,0x6A,0x6A,0x6A,0x6A,0x61,0x51,0x53,0x55,0x5B,0x6A,0xFB,
  0x6A,0x59,0x57,0x55,0x59,0x6A,0xFB,0xFB,0xFB,0x6A,0x51,0x53,0x53,0x5C,0x6A,0xFB,
  0x6A,0x59,0x57,0x55,0x59,0x6A,0xFB,TRNP,TRNP,0x6A,0x53,0x51,0x51,0x59,0x6A,0xFB,
  0x6A,0x5F,0x61,0x61,0x5F,0x6A,0xFB,TRNP,TRNP,0x6A,0x5C,0x61,0x5F,0x5F,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_73 [] =
{
  16,13,0,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  TRNP,0x6A,0x59,0x53,0x51,0x51,0x51,0x51,0x55,0x59,0x55,0x5B,0x5F,0x61,0x6A,0xFB,
  0x6A,0x62,0x55,0x55,0x5C,0x62,0x64,0x62,0x61,0x61,0x61,0x66,0x68,0x64,0x6A,0xFB,
  0x6A,0x5F,0x55,0x55,0x5C,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  0x6A,0x5F,0x55,0x53,0x5C,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,
  0x6A,0x62,0x55,0x55,0x5B,0x53,0x51,0x51,0x51,0x55,0x55,0x59,0x61,0x6A,TRNP,TRNP,
  TRNP,0x6A,0x61,0x64,0x61,0x64,0x61,0x5F,0x61,0x64,0x64,0x5C,0x5C,0x62,0x6A,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x64,0x5C,0x5F,0x61,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x62,0x5C,0x5F,0x61,0x6A,0xFB,
  0x6A,0x5C,0x51,0x50,0x50,0x53,0x51,0x53,0x59,0x57,0x59,0x5C,0x5C,0x62,0x6A,0xFB,
  0x6A,0x61,0x61,0x5F,0x61,0x64,0x61,0x62,0x61,0x5F,0x5F,0x61,0x64,0x6A,0xFB,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_74 [] =
{
  13,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x5C,0x51,0x50,0x50,0x50,0x50,0x51,0x51,0x51,0x57,0x6A,0xFB,
  0x6A,0x62,0x62,0x59,0x59,0x50,0x53,0x59,0x5F,0x62,0x62,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x57,0x51,0x53,0x5B,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0x6A,0x57,0x53,0x59,0x59,0x6A,0xFB,0xFB,0xFB,0xFB,
  TRNP,TRNP,TRNP,0x6A,0x57,0x50,0x57,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x57,0x50,0x57,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x57,0x51,0x55,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x57,0x53,0x53,0x5B,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x59,0x53,0x53,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x5F,0x5C,0x5C,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_75 [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x5B,0x51,0x51,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x5C,0x55,0x51,0x59,0x6A,0xFB,
  0x6A,0x61,0x62,0x62,0x62,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x61,0x5F,0x57,0x59,0x6A,0xFB,
  0x6A,0x62,0x62,0x62,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x5F,0x5B,0x5B,0x5B,0x6A,0xFB,
  0x6A,0x62,0x62,0x62,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x5F,0x5C,0x5C,0x5C,0x6A,0xFB,
  0x6A,0x64,0x62,0x61,0x61,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x62,0x61,0x61,0x5F,0x6A,0xFB,
  0x6A,0x64,0x62,0x61,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x62,0x62,0x61,0x5F,0x6A,0xFB,
  0x6A,0x62,0x62,0x61,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x62,0x61,0x5F,0x62,0x6A,0xFB,
  TRNP,0x6A,0x62,0x61,0x59,0x55,0x6A,0x6A,0x6A,0x6A,0x61,0x5F,0x5C,0x5C,0x6A,0xFB,0xFB,
  TRNP,0x6A,0x66,0x5C,0x5C,0x51,0x50,0x51,0x55,0x55,0x5C,0x5B,0x59,0x64,0x6A,0xFB,TRNP,
  TRNP,TRNP,0x6A,0x6A,0x64,0x61,0x61,0x62,0x66,0x64,0x5F,0x64,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_76 [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x5B,0x50,0x50,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x59,0x51,0x50,0x50,0x6A,0xFB,
  0x6A,0x5F,0x55,0x57,0x5B,0x6A,0xFB,TRNP,TRNP,TRNP,0x6A,0x59,0x55,0x55,0x5C,0x6A,0xFB,
  TRNP,0x6A,0x59,0x57,0x57,0x5F,0x6A,TRNP,TRNP,0x6A,0x5C,0x53,0x57,0x57,0x6A,0xFB,0xFB,
  TRNP,0x6A,0x5C,0x57,0x55,0x5C,0x6A,0xFB,TRNP,0x6A,0x59,0x55,0x57,0x5C,0x6A,0xFB,TRNP,
  TRNP,TRNP,0x6A,0x59,0x59,0x59,0x5F,0x6A,0x6A,0x5C,0x57,0x55,0x53,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,0x6A,0x5C,0x55,0x59,0x59,0x5F,0x5F,0x53,0x57,0x51,0x5C,0x6A,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x55,0x57,0x57,0x51,0x51,0x55,0x55,0x51,0x6A,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x5C,0x55,0x59,0x55,0x51,0x57,0x55,0x5C,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x55,0x59,0x5B,0x55,0x53,0x51,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x62,0x62,0x64,0x5C,0x5B,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_77 [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x59,0x51,0x57,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x59,0x5C,0x6A,0xFB,
  0x6A,0x5B,0x57,0x5B,0x6A,0xFB,TRNP,0x6A,0x6A,TRNP,TRNP,0x6A,0x64,0x66,0x61,0x6A,0xFB,
  0x6A,0x5B,0x57,0x5B,0x6A,0xFB,0x6A,0x51,0x51,0x6A,TRNP,0x6A,0x62,0x64,0x5F,0x6A,0xFB,
  0x6A,0x5B,0x57,0x5B,0x6A,0x6A,0x51,0x5B,0x5C,0x51,0x6A,0x6A,0x61,0x62,0x5F,0x6A,0xFB,
  0x6A,0x5C,0x5B,0x5B,0x6A,0x51,0x5C,0x5B,0x5B,0x5B,0x55,0x6A,0x61,0x5F,0x5F,0x6A,0xFB,
  0x6A,0x5B,0x55,0x59,0x53,0x55,0x5B,0x5B,0x59,0x5C,0x62,0x62,0x5F,0x5C,0x5F,0x6A,0xFB,
  0x6A,0x59,0x53,0x53,0x51,0x53,0x5C,0x64,0x62,0x5F,0x62,0x62,0x5C,0x5F,0x5C,0x6A,0xFB,
  0x6A,0x59,0x57,0x55,0x51,0x53,0x64,0x6A,0x6A,0x62,0x61,0x61,0x5C,0x5F,0x5C,0x6A,0xFB,
  0x6A,0x61,0x57,0x53,0x51,0x5C,0x6A,0xFB,0xFB,0x6A,0x61,0x59,0x5C,0x5C,0x5F,0x6A,0xFB,
  TRNP,0x6A,0x62,0x61,0x64,0x6A,0xFB,0xFB,TRNP,TRNP,0x6A,0x66,0x64,0x66,0x6A,0xFB,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,TRNP,TRNP
};

static const unsigned char wilv_char_78 [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x55,0x55,0x50,0x50,0x6A,TRNP,TRNP,TRNP,TRNP,0x6A,0x51,0x51,0x50,0x51,0x6A,0xFB,
  0x6A,0x62,0x5F,0x57,0x51,0x53,0x6A,TRNP,TRNP,0x6A,0x51,0x57,0x55,0x57,0x5F,0x6A,0xFB,
  0x6A,0x6A,0x61,0x5B,0x55,0x53,0x53,0x6A,0x6A,0x53,0x57,0x59,0x57,0x5F,0x6A,0xFB,0xFB,
  TRNP,0xFB,0x6A,0x61,0x59,0x51,0x57,0x50,0x50,0x57,0x55,0x59,0x5F,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x61,0x51,0x5B,0x59,0x57,0x59,0x59,0x5F,0x6A,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x51,0x57,0x5B,0x51,0x59,0x59,0x51,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,0x6A,0x61,0x59,0x51,0x57,0x50,0x50,0x57,0x55,0x59,0x5F,0x6A,TRNP,TRNP,TRNP,
  0x6A,0x6A,0x61,0x5B,0x55,0x53,0x53,0x6A,0x6A,0x53,0x57,0x59,0x57,0x5F,0x6A,TRNP,TRNP,
  0x6A,0x62,0x5F,0x57,0x51,0x53,0x6A,0xFB,0xFB,0x6A,0x51,0x57,0x55,0x57,0x5F,0x6A,TRNP,
  0x6A,0x55,0x55,0x50,0x50,0x6A,0xFB,0xFB,TRNP,TRNP,0x6A,0x51,0x51,0x50,0x51,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_79 [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x55,0x55,0x50,0x50,0x6A,TRNP,TRNP,TRNP,TRNP,0x6A,0x51,0x51,0x50,0x51,0x6A,0xFB,
  0x6A,0x62,0x5F,0x57,0x51,0x53,0x6A,TRNP,TRNP,0x6A,0x51,0x57,0x55,0x57,0x5F,0x6A,0xFB,
  0x6A,0x6A,0x61,0x5B,0x55,0x53,0x53,0x6A,0x6A,0x53,0x57,0x59,0x57,0x5F,0x6A,0xFB,0xFB,
  TRNP,0xFB,0x6A,0x61,0x59,0x51,0x57,0x50,0x50,0x57,0x55,0x59,0x5F,0x6A,0xFB,0xFB,TRNP,
  TRNP,TRNP,TRNP,0x6A,0x61,0x51,0x5B,0x59,0x59,0x59,0x59,0x5F,0x6A,0xFB,0xFB,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,0x6A,0x5C,0x5B,0x59,0x59,0x57,0x5C,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x5F,0x59,0x59,0x5B,0x6A,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x61,0x59,0x57,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x5C,0x57,0x59,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x62,0x61,0x5F,0x5F,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP,
  TRNP,TRNP,TRNP,TRNP,TRNP,TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,TRNP
};

static const unsigned char wilv_char_7A [] =
{
  17,13,0,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x57,0x50,0x50,0x50,0x51,0x50,0x50,0x50,0x50,0x51,0x50,0x51,0x51,0x5B,0x6A,0xFB,
  0x6A,0x5F,0x5C,0x5B,0x5C,0x5F,0x5C,0x59,0x50,0x57,0x57,0x55,0x55,0x59,0x5C,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x53,0x57,0x57,0x55,0x55,0x55,0x59,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0x6A,0x6A,0x55,0x51,0x57,0x57,0x55,0x53,0x61,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,0x6A,0x6A,0x55,0x50,0x55,0x57,0x59,0x5B,0x61,0x6A,0x6A,0xFB,0xFB,0xFB,
  TRNP,0x6A,0x6A,0x55,0x51,0x53,0x51,0x55,0x53,0x61,0x6A,0x6A,0xFB,0xFB,0xFB,TRNP,TRNP,
  0x6A,0x5B,0x50,0x55,0x55,0x55,0x51,0x61,0x6A,0x6A,0xFB,0xFB,0xFB,TRNP,TRNP,TRNP,TRNP,
  0x6A,0x59,0x53,0x53,0x57,0x53,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,TRNP,
  0x6A,0x59,0x51,0x51,0x53,0x57,0x51,0x50,0x50,0x50,0x51,0x50,0x50,0x50,0x57,0x6A,0xFB,
  0x6A,0x5F,0x5F,0x5B,0x5C,0x5C,0x5C,0x5B,0x59,0x5C,0x5F,0x5C,0x5B,0x5F,0x64,0x6A,0xFB,
  0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0x6A,0xFB,
  TRNP,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB,0xFB
};

static const unsigned char wilv_char_7F [] =
{
  6,6,0,
  0x6A,0x6A,0x6A,0x6A,TRNP,TRNP,
  0x6A,0x51,0x51,0x6A,0xFB,TRNP,
  0x6A,0x57,0x5B,0x6A,0xFB,TRNP,
  TRNP,0x6A,0x5F,0x5F,0x6A,0xFB,
  TRNP,TRNP,0x6A,0x6A,0x6A,0xFB,
  TRNP,TRNP,TRNP,0xFB,0xFB,0xFB
};

#define wilv_char_22 NULL
#define wilv_char_23 NULL
#define wilv_char_24 NULL
#define wilv_char_25 NULL
#define wilv_char_26 NULL
#define wilv_char_28 NULL
#define wilv_char_29 NULL
#define wilv_char_2A NULL
#define wilv_char_2B NULL
#define wilv_char_2C NULL
#define wilv_char_3A NULL
#define wilv_char_3B NULL
#define wilv_char_3C NULL
#define wilv_char_3D NULL
#define wilv_char_3E NULL
#define wilv_char_3F NULL
#define wilv_char_40 NULL
#define wilv_char_41 wilv_char_61
#define wilv_char_42 wilv_char_62
#define wilv_char_43 wilv_char_63
#define wilv_char_44 wilv_char_64
#define wilv_char_45 wilv_char_65
#define wilv_char_46 wilv_char_66
#define wilv_char_47 wilv_char_67
#define wilv_char_48 wilv_char_68
#define wilv_char_49 wilv_char_69
#define wilv_char_4A wilv_char_6A
#define wilv_char_4B wilv_char_6B
#define wilv_char_4C wilv_char_6C
#define wilv_char_4D wilv_char_6D
#define wilv_char_4E wilv_char_6E
#define wilv_char_4F wilv_char_6F
#define wilv_char_50 wilv_char_70
#define wilv_char_51 wilv_char_71
#define wilv_char_52 wilv_char_72
#define wilv_char_53 wilv_char_73
#define wilv_char_54 wilv_char_74
#define wilv_char_55 wilv_char_75
#define wilv_char_56 wilv_char_76
#define wilv_char_57 wilv_char_77
#define wilv_char_58 wilv_char_78
#define wilv_char_59 wilv_char_79
#define wilv_char_5A wilv_char_7A
#define wilv_char_5B NULL
#define wilv_char_5C NULL
#define wilv_char_5D NULL
#define wilv_char_5E NULL
#define wilv_char_5F NULL
#define wilv_char_60 NULL
#define wilv_char_7B NULL
#define wilv_char_7C NULL
#define wilv_char_7D NULL
#define wilv_char_7E NULL

/* ---------------------------------------------------------------------------- */

static const unsigned char * red_charset [] =
{
  red_char_21, red_char_22, red_char_23, red_char_24,
  red_char_25, red_char_26, red_char_27, red_char_28,
  red_char_29, red_char_2A, red_char_2B, red_char_2C,
  red_char_2D, red_char_2E, red_char_2F, red_char_30,
  red_char_31, red_char_32, red_char_33, red_char_34,
  red_char_35, red_char_36, red_char_37, red_char_38,
  red_char_39, red_char_3A, red_char_3B, red_char_3C,
  red_char_3D, red_char_3E, red_char_3F, red_char_40,
  red_char_41, red_char_42, red_char_43, red_char_44,
  red_char_45, red_char_46, red_char_47, red_char_48,
  red_char_49, red_char_4A, red_char_4B, red_char_4C,
  red_char_4D, red_char_4E, red_char_4F, red_char_50,
  red_char_51, red_char_52, red_char_53, red_char_54,
  red_char_55, red_char_56, red_char_57, red_char_58,
  red_char_59, red_char_5A, red_char_5B, red_char_5C,
  red_char_5D, red_char_5E, red_char_5F, red_char_60,
  red_char_61, red_char_62, red_char_63, red_char_64,
  red_char_65, red_char_66, red_char_67, red_char_68,
  red_char_69, red_char_6A, red_char_6B, red_char_6C,
  red_char_6D, red_char_6E, red_char_6F, red_char_70,
  red_char_71, red_char_72, red_char_73, red_char_74,
  red_char_75, red_char_76, red_char_77, red_char_78,
  red_char_79, red_char_7A, red_char_7B, red_char_7C,
  red_char_7D, red_char_7E, red_char_7F
};

/* ---------------------------------------------------------------------------- */

static const unsigned char * wilv_charset [] =
{
  wilv_char_21, wilv_char_22, wilv_char_23, wilv_char_24,
  wilv_char_25, wilv_char_26, wilv_char_27, wilv_char_28,
  wilv_char_29, wilv_char_2A, wilv_char_2B, wilv_char_2C,
  wilv_char_2D, wilv_char_2E, wilv_char_2F, wilv_char_30,
  wilv_char_31, wilv_char_32, wilv_char_33, wilv_char_34,
  wilv_char_35, wilv_char_36, wilv_char_37, wilv_char_38,
  wilv_char_39, wilv_char_3A, wilv_char_3B, wilv_char_3C,
  wilv_char_3D, wilv_char_3E, wilv_char_3F, wilv_char_40,
  wilv_char_41, wilv_char_42, wilv_char_43, wilv_char_44,
  wilv_char_45, wilv_char_46, wilv_char_47, wilv_char_48,
  wilv_char_49, wilv_char_4A, wilv_char_4B, wilv_char_4C,
  wilv_char_4D, wilv_char_4E, wilv_char_4F, wilv_char_50,
  wilv_char_51, wilv_char_52, wilv_char_53, wilv_char_54,
  wilv_char_55, wilv_char_56, wilv_char_57, wilv_char_58,
  wilv_char_59, wilv_char_5A, wilv_char_5B, wilv_char_5C,
  wilv_char_5D, wilv_char_5E, wilv_char_5F, wilv_char_60,
  wilv_char_61, wilv_char_62, wilv_char_63, wilv_char_64,
  wilv_char_65, wilv_char_66, wilv_char_67, wilv_char_68,
  wilv_char_69, wilv_char_6A, wilv_char_6B, wilv_char_6C,
  wilv_char_6D, wilv_char_6E, wilv_char_6F, wilv_char_70,
  wilv_char_71, wilv_char_72, wilv_char_73, wilv_char_74,
  wilv_char_75, wilv_char_76, wilv_char_77, wilv_char_78,
  wilv_char_79, wilv_char_7A, wilv_char_7B, wilv_char_7C,
  wilv_char_7D, wilv_char_7E, wilv_char_7F
};

/* ---------------------------------------------------------------------------- */

static patch_t * big_font [ARRAY_SIZE (wilv_charset)];

/* ---------------------------------------------------------------------------- */

typedef struct
{
  char char1;
  char char2;
  unsigned char adjust;
} kern_t;

static const kern_t m_kern [] =
{
  { '-', 'V', 2 },
  { 'f', 'e', 1 },
  { 'f', 'f', 1 },
  { 'f', 'o', 1 },
  { 'l', 'e', 1 },
  { 'l', 't', 1 },
  { 'l', 'u', 1 },
  { 'o', 'a', 1 },
  { 'O', 'A', 1 },
  { 'o', 't', 1 },
  { 'p', 'a', 2 },
  { 'P', 'a', 3 },
  { 't', 'a', 2 },
  { 't', 'o', 1 },
  { 'v', 'e', 1 },
  { 'V', 'o', 2 },
  { 'y', '.', 2 },
  { 'y', ',', 3 },
  { 'y', 'o', 1 },
  { 0, 0, 0 }
};

/* Wilv charset is case independent .... */

static const kern_t w_kern [] =
{
  { 'f', 'e', 1 },
  { 'f', 'f', 1 },
  { 'f', 'o', 1 },
  { 'l', 'e', 1 },
  { 'l', 't', 1 },
  { 'l', 'u', 1 },
  { 'o', 'a', 1 },
  { 'o', 't', 1 },
  { 'p', 'a', 2 },
  { 't', 'a', 2 },
  { 't', 'o', 1 },
  { 'v', 'e', 1 },
  { 'y', '.', 2 },
  { 'y', ',', 3 },
  { 'y', 'o', 1 },

  { 'F', 'e', 1 },
  { 'F', 'f', 1 },
  { 'F', 'o', 1 },
  { 'L', 'e', 1 },
  { 'L', 't', 1 },
  { 'L', 'u', 1 },
  { 'O', 'a', 1 },
  { 'O', 't', 1 },
  { 'P', 'a', 2 },
  { 'T', 'a', 2 },
  { 'T', 'o', 1 },
  { 'V', 'e', 1 },
  { 'Y', '.', 2 },
  { 'Y', ',', 3 },
  { 'Y', 'o', 1 },

  { 'f', 'E', 1 },
  { 'f', 'F', 1 },
  { 'f', 'O', 1 },
  { 'l', 'E', 1 },
  { 'l', 'T', 1 },
  { 'l', 'U', 1 },
  { 'o', 'A', 1 },
  { 'o', 'T', 1 },
  { 'p', 'A', 2 },
  { 't', 'A', 2 },
  { 't', 'O', 1 },
  { 'v', 'E', 1 },
  { 'y', '.', 2 },
  { 'y', ',', 3 },
  { 'y', 'O', 1 },

  { 'F', 'E', 1 },
  { 'F', 'F', 1 },
  { 'F', 'O', 1 },
  { 'L', 'E', 1 },
  { 'L', 'T', 1 },
  { 'L', 'U', 1 },
  { 'O', 'A', 1 },
  { 'O', 'T', 1 },
  { 'P', 'A', 2 },
  { 'T', 'A', 2 },
  { 'T', 'O', 1 },
  { 'V', 'E', 1 },
  { 'Y', '.', 2 },
  { 'Y', ',', 3 },
  { 'Y', 'O', 1 },

  { 0, 0, 0 }
};

/* ---------------------------------------------------------------------------- */

const unsigned char PLAYPAL [] =
{
  0x00, 0x00, 0x00, 0x1F, 0x17, 0x0B, 0x17, 0x0F, 0x07, 0x4B, 0x4B, 0x4B, 0xFF, 0xFF, 0xFF,
  0x1B, 0x1B, 0x1B, 0x13, 0x13, 0x13, 0x0B, 0x0B, 0x0B, 0x07, 0x07, 0x07, 0x2F, 0x37, 0x1F,
  0x23, 0x2B, 0x0F, 0x17, 0x1F, 0x07, 0x0F, 0x17, 0x00, 0x4F, 0x3B, 0x2B, 0x47, 0x33, 0x23,
  0x3F, 0x2B, 0x1B, 0xFF, 0xB7, 0xB7, 0xF7, 0xAB, 0xAB, 0xF3, 0xA3, 0xA3, 0xEB, 0x97, 0x97,
  0xE7, 0x8F, 0x8F, 0xDF, 0x87, 0x87, 0xDB, 0x7B, 0x7B, 0xD3, 0x73, 0x73, 0xCB, 0x6B, 0x6B,
  0xC7, 0x63, 0x63, 0xBF, 0x5B, 0x5B, 0xBB, 0x57, 0x57, 0xB3, 0x4F, 0x4F, 0xAF, 0x47, 0x47,
  0xA7, 0x3F, 0x3F, 0xA3, 0x3B, 0x3B, 0x9B, 0x33, 0x33, 0x97, 0x2F, 0x2F, 0x8F, 0x2B, 0x2B,
  0x8B, 0x23, 0x23, 0x83, 0x1F, 0x1F, 0x7F, 0x1B, 0x1B, 0x77, 0x17, 0x17, 0x73, 0x13, 0x13,
  0x6B, 0x0F, 0x0F, 0x67, 0x0B, 0x0B, 0x5F, 0x07, 0x07, 0x5B, 0x07, 0x07, 0x53, 0x07, 0x07,
  0x4F, 0x00, 0x00, 0x47, 0x00, 0x00, 0x43, 0x00, 0x00, 0xFF, 0xEB, 0xDF, 0xFF, 0xE3, 0xD3,
  0xFF, 0xDB, 0xC7, 0xFF, 0xD3, 0xBB, 0xFF, 0xCF, 0xB3, 0xFF, 0xC7, 0xA7, 0xFF, 0xBF, 0x9B,
  0xFF, 0xBB, 0x93, 0xFF, 0xB3, 0x83, 0xF7, 0xAB, 0x7B, 0xEF, 0xA3, 0x73, 0xE7, 0x9B, 0x6B,
  0xDF, 0x93, 0x63, 0xD7, 0x8B, 0x5B, 0xCF, 0x83, 0x53, 0xCB, 0x7F, 0x4F, 0xBF, 0x7B, 0x4B,
  0xB3, 0x73, 0x47, 0xAB, 0x6F, 0x43, 0xA3, 0x6B, 0x3F, 0x9B, 0x63, 0x3B, 0x8F, 0x5F, 0x37,
  0x87, 0x57, 0x33, 0x7F, 0x53, 0x2F, 0x77, 0x4F, 0x2B, 0x6B, 0x47, 0x27, 0x5F, 0x43, 0x23,
  0x53, 0x3F, 0x1F, 0x4B, 0x37, 0x1B, 0x3F, 0x2F, 0x17, 0x33, 0x2B, 0x13, 0x2B, 0x23, 0x0F,
  0xEF, 0xEF, 0xEF, 0xE7, 0xE7, 0xE7, 0xDF, 0xDF, 0xDF, 0xDB, 0xDB, 0xDB, 0xD3, 0xD3, 0xD3,
  0xCB, 0xCB, 0xCB, 0xC7, 0xC7, 0xC7, 0xBF, 0xBF, 0xBF, 0xB7, 0xB7, 0xB7, 0xB3, 0xB3, 0xB3,
  0xAB, 0xAB, 0xAB, 0xA7, 0xA7, 0xA7, 0x9F, 0x9F, 0x9F, 0x97, 0x97, 0x97, 0x93, 0x93, 0x93,
  0x8B, 0x8B, 0x8B, 0x83, 0x83, 0x83, 0x7F, 0x7F, 0x7F, 0x77, 0x77, 0x77, 0x6F, 0x6F, 0x6F,
  0x6B, 0x6B, 0x6B, 0x63, 0x63, 0x63, 0x5B, 0x5B, 0x5B, 0x57, 0x57, 0x57, 0x4F, 0x4F, 0x4F,
  0x47, 0x47, 0x47, 0x43, 0x43, 0x43, 0x3B, 0x3B, 0x3B, 0x37, 0x37, 0x37, 0x2F, 0x2F, 0x2F,
  0x27, 0x27, 0x27, 0x23, 0x23, 0x23, 0x77, 0xFF, 0x6F, 0x6F, 0xEF, 0x67, 0x67, 0xDF, 0x5F,
  0x5F, 0xCF, 0x57, 0x5B, 0xBF, 0x4F, 0x53, 0xAF, 0x47, 0x4B, 0x9F, 0x3F, 0x43, 0x93, 0x37,
  0x3F, 0x83, 0x2F, 0x37, 0x73, 0x2B, 0x2F, 0x63, 0x23, 0x27, 0x53, 0x1B, 0x1F, 0x43, 0x17,
  0x17, 0x33, 0x0F, 0x13, 0x23, 0x0B, 0x0B, 0x17, 0x07, 0xBF, 0xA7, 0x8F, 0xB7, 0x9F, 0x87,
  0xAF, 0x97, 0x7F, 0xA7, 0x8F, 0x77, 0x9F, 0x87, 0x6F, 0x9B, 0x7F, 0x6B, 0x93, 0x7B, 0x63,
  0x8B, 0x73, 0x5B, 0x83, 0x6B, 0x57, 0x7B, 0x63, 0x4F, 0x77, 0x5F, 0x4B, 0x6F, 0x57, 0x43,
  0x67, 0x53, 0x3F, 0x5F, 0x4B, 0x37, 0x57, 0x43, 0x33, 0x53, 0x3F, 0x2F, 0x9F, 0x83, 0x63,
  0x8F, 0x77, 0x53, 0x83, 0x6B, 0x4B, 0x77, 0x5F, 0x3F, 0x67, 0x53, 0x33, 0x5B, 0x47, 0x2B,
  0x4F, 0x3B, 0x23, 0x43, 0x33, 0x1B, 0x7B, 0x7F, 0x63, 0x6F, 0x73, 0x57, 0x67, 0x6B, 0x4F,
  0x5B, 0x63, 0x47, 0x53, 0x57, 0x3B, 0x47, 0x4F, 0x33, 0x3F, 0x47, 0x2B, 0x37, 0x3F, 0x27,
  0xFF, 0xFF, 0x73, 0xEB, 0xDB, 0x57, 0xD7, 0xBB, 0x43, 0xC3, 0x9B, 0x2F, 0xAF, 0x7B, 0x1F,
  0x9B, 0x5B, 0x13, 0x87, 0x43, 0x07, 0x73, 0x2B, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xDB, 0xDB,
  0xFF, 0xBB, 0xBB, 0xFF, 0x9B, 0x9B, 0xFF, 0x7B, 0x7B, 0xFF, 0x5F, 0x5F, 0xFF, 0x3F, 0x3F,
  0xFF, 0x1F, 0x1F, 0xFF, 0x00, 0x00, 0xEF, 0x00, 0x00, 0xE3, 0x00, 0x00, 0xD7, 0x00, 0x00,
  0xCB, 0x00, 0x00, 0xBF, 0x00, 0x00, 0xB3, 0x00, 0x00, 0xA7, 0x00, 0x00, 0x9B, 0x00, 0x00,
  0x8B, 0x00, 0x00, 0x7F, 0x00, 0x00, 0x73, 0x00, 0x00, 0x67, 0x00, 0x00, 0x5B, 0x00, 0x00,
  0x4F, 0x00, 0x00, 0x43, 0x00, 0x00, 0xE7, 0xE7, 0xFF, 0xC7, 0xC7, 0xFF, 0xAB, 0xAB, 0xFF,
  0x8F, 0x8F, 0xFF, 0x73, 0x73, 0xFF, 0x53, 0x53, 0xFF, 0x37, 0x37, 0xFF, 0x1B, 0x1B, 0xFF,
  0x00, 0x00, 0xFF, 0x00, 0x00, 0xE3, 0x00, 0x00, 0xCB, 0x00, 0x00, 0xB3, 0x00, 0x00, 0x9B,
  0x00, 0x00, 0x83, 0x00, 0x00, 0x6B, 0x00, 0x00, 0x53, 0xFF, 0xFF, 0xFF, 0xFF, 0xEB, 0xDB,
  0xFF, 0xD7, 0xBB, 0xFF, 0xC7, 0x9B, 0xFF, 0xB3, 0x7B, 0xFF, 0xA3, 0x5B, 0xFF, 0x8F, 0x3B,
  0xFF, 0x7F, 0x1B, 0xF3, 0x73, 0x17, 0xEB, 0x6F, 0x0F, 0xDF, 0x67, 0x0F, 0xD7, 0x5F, 0x0B,
  0xCB, 0x57, 0x07, 0xC3, 0x4F, 0x00, 0xB7, 0x47, 0x00, 0xAF, 0x43, 0x00, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xD7, 0xFF, 0xFF, 0xB3, 0xFF, 0xFF, 0x8F, 0xFF, 0xFF, 0x6B, 0xFF, 0xFF, 0x47,
  0xFF, 0xFF, 0x23, 0xFF, 0xFF, 0x00, 0xA7, 0x3F, 0x00, 0x9F, 0x37, 0x00, 0x93, 0x2F, 0x00,
  0x87, 0x23, 0x00, 0x4F, 0x3B, 0x27, 0x43, 0x2F, 0x1B, 0x37, 0x23, 0x13, 0x2F, 0x1B, 0x0B,
  0x00, 0x00, 0x53, 0x00, 0x00, 0x47, 0x00, 0x00, 0x3B, 0x00, 0x00, 0x2F, 0x00, 0x00, 0x23,
  0x00, 0x00, 0x17, 0x00, 0x00, 0x0B, 0x00, 0x00, 0x00, 0xFF, 0x9F, 0x43, 0xFF, 0xE7, 0x4B,
  0xFF, 0x7B, 0xFF, 0xFF, 0x00, 0xFF, 0xCF, 0x00, 0xCF, 0x9F, 0x00, 0x9B, 0x6F, 0x00, 0x6B,
  0xA7, 0x6B, 0x6B
};

/* ---------------------------------------------------------------------------- */

static unsigned int gen_kern (char this_one, char next_one, const kern_t * kern)
{
  unsigned int rc;

  rc = kern -> adjust;

  do
  {
    if ((this_one == kern -> char1) && (next_one == kern -> char2))
      break;
    kern++;
  } while ((rc = kern -> adjust) != 0);

  return (rc);
}

/* ---------------------------------------------------------------------------- */

static unsigned int V_textwidth (const char * str, const unsigned char * const * charset, const kern_t * kern)
{
  unsigned int w;
  unsigned int j;
  unsigned char cc;
  patch_t * patch;
  const unsigned char * p;

  w = 0;
  do
  {
    cc = *str++;
    if (cc == 0)
      break;

    j = 6;			// Assume unused character
    if (cc >= FONT_START)
    {
      cc -= FONT_START;
      if (cc < ARRAY_SIZE (wilv_charset))
      {
#if 0
	if ((charset == red_charset)
	 && ((patch = big_font[cc]) != NULL))
#else
	if ((patch = big_font[cc]) != NULL)
#endif
	{
	  j = SHORT(patch->width);
	  j -= gen_kern (cc+FONT_START, *str, kern);
	}
	else if ((p = charset [cc]) != NULL)
	{
	  j = (*p - 2) - gen_kern (cc+FONT_START, *str, kern);
	}
      }
    }
    w += j;
  } while (1);

  return (w);
}

/* ---------------------------------------------------------------------------- */

static unsigned int V_drawMenuchar (int x, int y, int i)
{
  unsigned int width,height;
  unsigned int cols;
  unsigned int blank_lines;
  const unsigned char * p;
  patch_t * patch;

  if ((i < FONT_START)
   || (((i-=FONT_START) >= ARRAY_SIZE (red_charset))))
    return (6);

  patch = big_font[i];
  if (patch)
  {
    V_DrawPatchScaled (x, y, 0, patch);
    return (SHORT(patch->width));
  }

  if ((p = red_charset [i]) == NULL)
    return (6);

  width = *p++;
  height = *p++;
  blank_lines = *p++;
  y += blank_lines;
  do
  {
    cols = 0;
    do
    {
      V_DrawPixelScaled (x + cols, y, 0, *p++, true);
    } while (++cols < width);
    y++;
  } while (--height);

  return (width - 2);
}

/* ---------------------------------------------------------------------------- */

unsigned int V_drawMenuText (int x, int y, const char *str)
{
  unsigned char cc;
  unsigned int j;

  do
  {
    cc = *str++;
    if (cc == 0)
      break;

    j = V_drawMenuchar (x, y, cc);
    j -= gen_kern (cc, *str, m_kern);
    x += j;
    if (x > 320)
      return (0);
  } while (1);

  return (red_charset [0][1]);
}

/* ---------------------------------------------------------------------------- */

unsigned int V_MenuTextWidth (const char * str)
{
  return (V_textwidth (str, red_charset, m_kern));
}

/* ---------------------------------------------------------------------------- */
#if 0
void V_drawMenuTextCentered (int y, const char *str)
{
  unsigned int x;
  unsigned int w;

  w = V_textwidth (str, red_charset, m_kern);

  if (w >= 320)
    x = 0;
  else
    x = (320 - w - 1) / 2;

  V_drawMenuText (x, y, str);
}
#endif
/* ---------------------------------------------------------------------------- */

static unsigned int V_drawWILVchar (int x, int y, int i)
{
  unsigned int width,height;
  unsigned int cols;
  unsigned int blank_lines;
  patch_t * patch;
  const unsigned char * p;

  if ((i < FONT_START)
   || (((i-=FONT_START) >= ARRAY_SIZE (wilv_charset))))
    return (6);

  patch = big_font[i];
  if (patch)
  {
    V_DrawPatchScaled (x, y, 0, patch);
    return (SHORT(patch->width));
  }

  if ((p = wilv_charset [i]) == NULL)
    return (6);

  width = *p++;
  height = *p++;
  blank_lines = *p++;
  y += blank_lines;
  do
  {
    cols = 0;
    do
    {
      V_DrawPixelScaled (x + cols, y, 0, *p++, true);
    } while (++cols < width);
    y++;
  } while (--height);

  return (width - 2);
}

/* ---------------------------------------------------------------------------- */
/*
   Returns height of characters.
*/

unsigned int V_drawWILV (int y, const char *str)
{
  unsigned char cc;
  unsigned int c;
  unsigned int h;
  unsigned int i;
  unsigned int j;
  unsigned int x;
  unsigned int w;
  unsigned int highest;
  patch_t * patch;
  const unsigned char * p;

  w = V_textwidth (str, wilv_charset, w_kern);

  if (w >= 320)
    x = 0;
  else
    x = (320 - w - 1) / 2;

  highest = 0;
  i = 0;
  do
  {
    cc = str [i];
    if (cc == 0)
      break;

    j = 6;			// Assume unused character

    if (cc >= FONT_START)
    {
      if (cc == '\'' && (!i || (i > 0 && str[i - 1] == ' ')))
	cc = 0x7F;

      c = cc - FONT_START;
      if ((c < ARRAY_SIZE (wilv_charset)))
      {
	h = 0;
	patch = big_font [c];
	if (patch)
	{
	  h = SHORT(patch->height);
	}
	else if ((p = wilv_charset [c]) != NULL)
	{
	  h = p [1] + p [2];
	}
	if (h > highest)
	  highest = h;
      }

      j = V_drawWILVchar (x, y, cc);
      j -= gen_kern (cc, str[i+1], w_kern);
    }
    x += j;
    i++;
  } while (x < 320);

  return (highest);
}

/* ---------------------------------------------------------------------------- */
//#define SAVE_PATCHES_FOR_TEXT

#ifdef SAVE_PATCHES_FOR_TEXT

static void save_patch (patch_t * patch, int ascii)
{
  unsigned int x;
  unsigned int y;
  byte* source;
  FILE * fout;

  fout = fopen ("/users/jeff/charset", "a");
  if (fout)
  {
    memset (screens[1], TRNP, SCREENHEIGHT*SCREENWIDTH);
    V_DrawPatchScaleFlip (0, 0, 1, patch, FRACUNIT, FRACUNIT, 0);

    fprintf (fout, "static const unsigned char red_char_%02X [] =\n{\n", ascii);
    fprintf (fout, "  %u,%u,0,\n", SHORT(patch->width), SHORT(patch->height));
    y = 0;
    do
    {
      source = screens[1] + (y*SCREENWIDTH);
      fprintf (fout, "  ");
      x = 0;
      do
      {
	fprintf (fout, "0x%02X", source[x]);
	if (((y+1) < SHORT(patch->height)) || ((x+1) < SHORT(patch->width)))
	  fprintf (fout, ",");
      } while (++x < SHORT(patch->width));
      fprintf (fout, "\n");
    } while (++y < SHORT(patch->height));

    fprintf (fout, "};\n\n");
    fclose (fout);
    printf ("Made file for font %02X\n", ascii);
  }
}

#endif

/* -------------------------------------------------------------------------------------------- */

static int V_Load_FON1 (const unsigned char * charset[], const byte * ptr, const byte * palette)
{
  unsigned int pos;
  unsigned int char_height;
  unsigned int char_width;
  unsigned int run_length;
  unsigned int the_char;
  unsigned int count;
  unsigned int bytes_req;
  byte * buffer;
  byte * bptr;
  byte * chardef;
  unsigned char colours [256];

  char_width  = ptr [4] | (ptr [5] << 8);
  char_height = ptr [6] | (ptr [7] << 8);

  ptr += 8;

  bytes_req = char_height * char_width * 256;
  buffer = malloc (bytes_req);
  if (buffer == NULL)
    return (0);

  /* The data is a grey scale */
				// TRNP ???
  colours [0] = 0;		// Miss out 1st one which is the transparent colour
  count = 1;
  do
  {
    colours [count] = AM_load_colour (count, count, count, palette);
  } while (++count < 256);


  /* And finally the RLE encoded info. */
  /* 1st byte =	0-127	= use next 1-128 data bytes */
  /*		128-255	= use next byte 2-132 times (where 255 = 2) */

  bptr = buffer;
  do
  {
    run_length = *ptr++;
    if (run_length < 0x80)
    {
      run_length++;
      /* Use the next n bytes */
//    memcpy (bptr, ptr, run_length);
      count = 0;
      do
      {
	bptr [count] = colours [ptr [count]];
      } while (++count < run_length);
      ptr += run_length;
    }
    else
    {
      run_length = 257 - run_length;
      the_char = *ptr++;
      /* Use this byte n times */
      memset (bptr, colours [the_char], run_length);
    }

    bptr += run_length;

//  printf ("Run length = %u, char = %X, left = %d\n", run_length, the_char, bytes_req-run_length);

    bytes_req -= run_length;
  } while (bytes_req);

  /* Now copy to the correct place */
  pos = 0;
  bptr = buffer;
  bytes_req = char_height * char_width;
  do
  {
    if ((pos >= FONT_START)	// Hard code range for now!
     && (pos <= FONT_END))
    {
      chardef = malloc (bytes_req + 3);
      if (chardef)
      {
	chardef [0] = char_width;
	chardef [1] = char_height;
	chardef [2] = 0;
	memcpy (chardef+3, bptr, bytes_req);
	charset [pos-0x21] = chardef;
      }
    }
    bptr += bytes_req;
  } while (++pos < 256);

  free (buffer);
  return (1);
}

/* -------------------------------------------------------------------------------------------- */

static int V_Load_FON2 (const unsigned char * charset[], const byte * ptr, const byte * palette)
{
  unsigned int first;
  unsigned int last;
  unsigned int char_height;
  unsigned int char_width;
  unsigned int palette_size;
  unsigned int constant_width;
  unsigned int char_num;
  unsigned int run_length;
  unsigned int the_char;
  unsigned int count;
  unsigned int bytes_req;
  unsigned int colour_number;
  unsigned char c0,c1,c2;
  unsigned char * red_char;
  unsigned char * colnum;
  unsigned char char_widths [256];
  unsigned char colours [256];


  char_height = ptr [4] | (ptr [5] << 8);
  first = ptr [6];			// First ascii character
  last  = ptr [7];			// and the last

  memset (char_widths, 0, sizeof (char_widths));
  constant_width = ptr [8];
  palette_size = ptr [10];
  ptr += 11;
  if (*ptr++ & 1)
  {
    ptr += 2;
  }

  if (constant_width)
  {
    char_width = ptr [0] | (ptr [1] << 8);
    memset (char_widths + first, char_width, (last - first) + 1);
    ptr += 2;
  }
  else
  {
    char_num = first;
    do
    {
      char_widths [char_num] = ptr [0] | (ptr [1] << 8);
      ptr += 2;
    } while (++char_num <= last);
  }


  /* Read palette info */
  colnum = colours;
  *colnum++ = 0;		// TRNP ???
  ptr += 3;			// Miss out 1st one which is the transparent colour
  colour_number = 1;
  if (palette_size)
  {
    do
    {
      c0 = *ptr++;
      c1 = *ptr++;
      c2 = *ptr++;
      *colnum++ = AM_load_colour (c0, c1, c2, palette);
      colour_number++;
    } while (--palette_size);
  }

  if (colour_number < sizeof (colours))	// Did we fill the whole table?
  {
    do					// No - fill the rest.
    {
      *colnum++ = colour_number;
    } while (++colour_number < sizeof (colours));
  }

#if 0

  colour_number = 0;			// A bit of debug!
  colnum = colours;
  do
  {
    printf ("Colour table number %u = %u\n", colour_number, *colnum++);
  } while (++colour_number < sizeof (colours));

#endif

// ptr += (palette_size + 1) * 3;

  /* And finally the RLE encoded info. */
  /* 1st byte =	0-127	= use next 1-128 data bytes */
  /*		128-255	= use next byte 2-132 times (where 255 = 2) */

  char_num = first;
  do
  {
    if (char_widths [char_num])
    {
      bytes_req = char_widths [char_num] * char_height;

      red_char = malloc (bytes_req + 3);
      if (red_char)
      {
	if ((char_num >= 0x21)
	 && (char_num <= 0x7F))
	{
	  charset [char_num-0x21] = red_char;

	  /* If the other case is not present */
	  /* then copy this one across. */

	  if ((char_num >= 'A')
	   && (char_num <= 'Z')
	   && (char_widths [char_num+0x20] == 0))
	    charset [char_num-0x01] = red_char;

	  if ((char_num >= 'a')
	   && (char_num <= 'z')
	   && (char_widths [char_num-0x20] == 0))
	    charset [char_num-0x41] = red_char;
	}

	*red_char++ = char_widths [char_num];
	*red_char++ = char_height;
	*red_char++ = 0;

//	printf ("%X size %u x %u (%u)\n", char_num, char_widths [char_num], char_height, bytes_req);
	do
	{
	  run_length = *ptr++;
	  if (run_length < 0x80)
	  {
	    run_length++;
	    /* Use the next n bytes */
	    // memcpy (red_char, ptr, run_length);
	    count = 0;
	    do
	    {
	      red_char [count] = colours [ptr [count]];
	    } while (++count < run_length);
	    ptr += run_length;
	  }
	  else
	  {
	    run_length = 257 - run_length;
	    the_char = *ptr++;
	    /* Use this byte n times */
	    memset (red_char, colours [the_char], run_length);
	  }

	  red_char += run_length;

//	  printf ("Run length = %u, char = %X, left = %d\n", run_length, the_char, bytes_req-run_length);

	  bytes_req -= run_length;
	} while (bytes_req);
      }
    }
  } while (++char_num <= last);
//printf ("Bytes used = %X\n", ptr - fontlump);
  return (2);
}

/* -------------------------------------------------------------------------------------------- */

static int V_Load_Font (const unsigned char * charset[], const char * lumpname, const byte * palette)
{
  int rc;
  int lump;
  unsigned int length;
  byte * fontlump;

  rc = 0;

  lump = W_CheckNumForName (lumpname);
  if (lump != -1)
  {
    length = W_LumpLength (lump);
    if (length)
    {
      fontlump = W_CacheLumpNum (lump, PU_STATIC);
      if ((fontlump [0] == 'F')
       && (fontlump [1] == 'O')
       && (fontlump [2] == 'N'))
      {
	switch (fontlump [3])
	{
	  case '1':
	    rc = V_Load_FON1 (charset, fontlump, palette);
	    break;

	  case '2':
	    rc = V_Load_FON2 (charset, fontlump, palette);
	    break;
	}
      }
      Z_Free (fontlump);
    }
  }

  return (rc);
}

/* -------------------------------------------------------------------------------------------- */

static void V_SetFontPalette (const unsigned char * const * charset, byte * palette)
{
  int w;
  int pos;
  int height;
  int width;
  int offset;
  int colour;
  byte * p;
  const byte * q;

  pos = 0;
  do
  {
    p = (byte*) charset [pos];
    if (p != NULL)
    {
      width = *p++;
      height = *p++;
      offset = *p++;

      do
      {
	w = width;
	do
	{
	  colour = *p;
	  if (colour == TRNP)	// Transparent?
	  {
	    p++;
	  }
	  else
	  {
	    q = &PLAYPAL [colour * 3];
	    *p++ = AM_load_colour (q[0], q[1], q[2], palette);
	  }
	} while (--w);
      } while (--height);
    }
  } while (++pos < ARRAY_SIZE(red_charset));
}

/* -------------------------------------------------------------------------------------------- */

void V_LoadFonts (void)
{
  int i,j;
  int dopal;
  byte * palette;
  patch_t * patch;
  char buffer [12];

  i = 0;
  j = FONT_START;
  do
  {
    sprintf (buffer, "BIGFN%.3d", j);
    patch = (patch_t *) W_CacheLumpName0 (buffer, PU_STATIC);

    if ((j >= 'a') && (j <= 'z'))// If we are missing upper/lower case then point to the other case.
    {
      if (patch == NULL)
      {
	patch = big_font[i-0x20];
      }
      else if (big_font[i-0x20] == NULL)
      {
	big_font[i-0x20] = patch;
      }
    }
    big_font[i] = patch;
//  printf ("big_font[%c] = %lX\n", j, big_font[i]);
    j++;
  } while (++i < ARRAY_SIZE(big_font));

  palette = W_CacheLumpName ("PLAYPAL", PU_STATIC);
  dopal = 0;

//V_Load_Font (NULL, "CONFONT", palette);	// Test code

  if (V_Load_Font (red_charset, "DBIGFONT", palette) == 0)
    dopal |= 1;

  if (V_Load_Font (wilv_charset, "DBIGFONT", palette) == 0)
    dopal |= 2;

  if (memcmp (PLAYPAL, palette, sizeof (PLAYPAL)))
  {
    if (dopal & 1)
      V_SetFontPalette (red_charset, palette);

    if (dopal & 2)
      V_SetFontPalette (wilv_charset, palette);

    ST_SetPalette (palette);
  }
}

/* -------------------------------------------------------------------------------------------- */
